unit Acquisition;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,NIDAQmx,NIDAQmxCAPI_TLB, StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart,Init_DC,ArtMode;

procedure Initialize_AI0_AI1_AO0(rate :double; DeviceNumber :integer);
procedure Stop_AI0_AI1_AO0(DeviceNumber :integer);
procedure AI0_AI1_AO0(DeviceNumber :integer);//(var AI0,AI1,AO0 :double);

implementation
uses DCUnit1;

var
  ATask,CTask,buf  :LongInt;
  autoStart :boolean;
  ttt :string;
  k :integer;

procedure Initialize_AI0_AI1_AO0(rate :double; DeviceNumber :integer);
var
    Dev,chanAI,chanAO :PAnsiChar;
begin
  if DeviceNumber=0 then begin Init_ArtificialNeuron; exit; end;
  DAQmxCreateTask('',@ATask);
  DAQmxCreateTask('',@CTask);
  case DeviceNumber of
  1:  begin chanAI:='Dev1/ai0:1'; chanAO:='Dev1/ao0'; end;
  2:  begin chanAI:='Dev2/ai0:1'; chanAO:='Dev2/ao0'; end;
  3:  begin chanAI:='Dev3/ai0:1'; chanAO:='Dev3/ao0'; end;
  4:  begin chanAI:='Dev4/ai0:1'; chanAO:='Dev4/ao0'; end;
  5:  begin chanAI:='Dev5/ai0:1'; chanAO:='Dev5/ao0'; end;
  end;
  k:=DAQmxCreateAIVoltageChan(ATask,chanAI,'',DAQmx_Val_InputTermCfg_RSE{Diff - 7.02.2014}{DAQmx_Val_Cfg_Default},-10.0,10.0,DAQmx_Val_VoltageUnits1_Volts,NIL);
  k:=DAQmxCreateAOVoltageChan(CTask,chanAO,'',-10,10,DAQmx_Val_VoltageUnits2_Volts,NIL);
  if rate>0 then begin
     k:=DAQmxCfgSampClkTiming(ATask,'',rate,DAQmx_Val_Falling,DAQmx_Val_AcquisitionType_HWTimedSinglePoint,2);
//feb13     k:=DAQmxSetBufOutputBufSize(CTask,2000024);
//feb13     k:=DAQmxCfgSampClkTiming(CTask,'',rate,DAQmx_Val_Rising,
//feb13        DAQmx_Val_AcquisitionType_ContSamps,1);
//             DAQmx_Val_AcquisitionType_FiniteSamps,10024);
     k:=DAQmxCfgSampClkTiming(CTask,'',rate,DAQmx_Val_Rising, DAQmx_Val_AcquisitionType_HWTimedSinglePoint,1);
  end;
  k:=DAQmxStartTask(ATask);
//feb13  k:=DAQmxWriteAnalogF64(CTask,1,false,10.0,DAQmx_Val_GroupByChannel,@d,@wr,NIL);
  k:=DAQmxStartTask(CTask);
end;

procedure Stop_AI0_AI1_AO0(DeviceNumber :integer);
var k :integer;
    data3 :double;
    read1,wr :LongInt;
begin
  if DeviceNumber=0 then exit;
  data3:=0;
//Feb13  k:=DAQmxWriteAnalogF64(CTask,1,false,5.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);
  DAQmxStopTask(ATask);
  DAQmxStopTask(CTask);
  k:=DAQmxClearTask(ATask);
  k:=DAQmxClearTask(CTask);
end;

procedure AI0_AI1_AO0(DeviceNumber :integer);//(var AI0,AI1,AO0 :double);
var k :integer;
    data1 :array[0..1] of double;
    data3 :double;
    read1,wr :LongInt;
begin
  if DeviceNumber=0 then begin Acquire_ArtificialNeuron;  exit; end;
  {*** Injected Current ***}
  data3:= (Icom - Icom_offset)/Icom_scale;
  { Check physiological limits }   // 7.05.2012
  if (V>Vmax)or(V<Vmin)or
     ((abs(V-Vprev)>dVmax{mV})and(Vprev<>0))or
     (abs(data3)>10) then begin
     data3:=0;
  end;
  {niDAQmx 8.3:}
  k:=DAQmxWriteAnalogF64(CTask,1,false,10.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);
  if k<0 then if DCForm1.Label85.Caption=' ' then begin DCForm1.Label85.Caption:='ErrorW='+IntToStr(k); Application.ProcessMessages; sleep(3000); DCForm1.Label85.Caption:=' '; end;
//feb13  k:=DAQmxWriteAnalogScalarF64(CTask,false,10.0,data3,NIL);
  {niDAQmx 7.4:}
  {  k:=DAQmxWriteAnalogF64(CTask,1,0,    5.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);}
  {*** Registered voltage and real current ***}
  Vprev:=V;
  k:=DAQmxReadAnalogF64(ATask,1,10.0,DAQmx_Val_GroupByChannel,@data1,2,@read1,NIL);
  if k<0 then if DCForm1.Label85.Caption=' ' then begin DCForm1.Label85.Caption:='ErrorR='+IntToStr(k); Application.ProcessMessages; sleep(3000); DCForm1.Label85.Caption:=' '; end;
  { Check acquisition limits }   // 7.05.2012
  if (abs(data1[0])>10)or(abs(data1[1])>10) then exit;     // 7.11.2011
  V     :=data1[0]*V_scale + V_offset;
  Ireal :=data1[1]*Ireal_scale + Ireal_offset;
//  Application.ProcessMessages;
end;

end.
