unit Acquisition;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,NIDAQmx,NIDAQmxCAPI_TLB, StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart,Init_DC,ArtMode;

procedure Initialize_AI0_AI1_AO0(rate :double; DeviceNumber :integer);
procedure Stop_AI0_AI1_AO0(DeviceNumber :integer);
procedure AI0_AI1_AO0(DeviceNumber :integer);//(var AI0,AI1,AO0 :double);

implementation

var
  ATask,BTask,CTask,buf,wr  :LongInt;
  autoStart :boolean;
  d :double;
  ttt :string;

procedure Initialize_AI0_AI1_AO0(rate :double; DeviceNumber :integer);
var k :integer;
    Dev,chanAI,chanAO :PAnsiChar;
begin
  if DeviceNumber=0 then begin Init_ArtificialNeuron; exit; end;
//  rate:=trunc(rate);
  k:=DAQmxCreateTask('',@ATask);
  d:=k*0;
//  DAQmxCreateTask('',@BTask);
  k:=DAQmxCreateTask('',@CTask);
  d:=k*0;
  case DeviceNumber of
  1:  begin chanAI:='Dev1/ai0:1'; chanAO:='Dev1/ao0'; end;
  2:  begin chanAI:='Dev2/ai0:1'; chanAO:='Dev2/ao0'; end;
  3:  begin chanAI:='Dev3/ai0:1'; chanAO:='Dev3/ao0'; end;
  end;
  k:=DAQmxCreateAIVoltageChan(ATask,chanAI,'',DAQmx_Val_InputTermCfg_Diff{DAQmx_Val_Cfg_Default},-10.0,10.0,DAQmx_Val_VoltageUnits1_Volts,NIL);
  d:=k*0;
//  k:=DAQmxCreateAIVoltageChan(BTask,'Dev1/ai1','',DAQmx_Val_InputTermCfg_Diff{DAQmx_Val_Cfg_Default},-10.0,10.0,DAQmx_Val_VoltageUnits1_Volts,NIL);
//  d:=k*0;
  k:=DAQmxCreateAOVoltageChan(CTask,chanAO,'',-10,10,DAQmx_Val_VoltageUnits2_Volts,NIL);
  d:=k*0;
  if rate>0 then begin
     k:=DAQmxCfgSampClkTiming(ATask,'',rate,DAQmx_Val_Rising,
     DAQmx_Val_AcquisitionType_HWTimedSinglePoint,2);
//*        DAQmx_Val_AcquisitionType_FiniteSamps,2000024);
//feb13        DAQmx_Val_AcquisitionType_ContSamps,2);
     d:=k*0;
//     k:=DAQmxCfgSampClkTiming(BTask,'',rate,DAQmx_Val_Rising,
//     DAQmx_Val_AcquisitionType_HWTimedSinglePoint,10024
//     {DAQmx_Val_AcquisitionType_FiniteSamps,10024});
//  d:=k*0;
     k:=DAQmxCfgSampClkTiming(CTask,'',rate,DAQmx_Val_Rising,
     DAQmx_Val_AcquisitionType_HWTimedSinglePoint,1);
//*     k:=DAQmxSetBufOutputBufSize(CTask,0);
//     d:=k*0;
//feb13     k:=DAQmxSetBufOutputBufSize(CTask,2000024);
     d:=k*0;
//feb13     k:=DAQmxCfgSampClkTiming(CTask,'',rate,DAQmx_Val_Rising,
//*        DAQmx_Val_AcquisitionType_FiniteSamps,2000024);
//feb13        DAQmx_Val_AcquisitionType_ContSamps,1);
     d:=k*0;
  end;
  k:=DAQmxStartTask(ATask);
  d:=k*0;
//  k:=DAQmxStartTask(BTask);
//  DAQmxGetExtendedErrorInfo (@ttt, 1024);
//  buf:=102400;
//  DAQmxGetErrorString(k,@ttt,buf);
//  d:=k*0;
//feb13  k:=DAQmxWriteAnalogF64(CTask,1,false,10.0,DAQmx_Val_GroupByChannel,@d,@wr,NIL);
  d:=k*0;
  k:=DAQmxStartTask(CTask);
  d:=k*0;
end;

procedure Stop_AI0_AI1_AO0(DeviceNumber :integer);
var k :integer;
    data3 :double;
    read1,wr :LongInt;
begin
  if DeviceNumber=0 then exit;
  k:=DAQmxStopTask(ATask);
  d:=k*0;
  k:=DAQmxClearTask(ATask);
  d:=k*0;
//  DAQmxStopTask(BTask);
  data3:=0;
  k:=DAQmxWriteAnalogF64(CTask,1,false,5.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);
  d:=k*0;
  k:=DAQmxStopTask(CTask);
  d:=k*0;
  k:=DAQmxClearTask(CTask);
  d:=k*0;
end;

procedure AI0_AI1_AO0(DeviceNumber :integer);//(var AI0,AI1,AO0 :double);
var k :integer;
    data1 :array[0..1] of double;
    data3 :double;
    read1,wr :LongInt;
begin
  if DeviceNumber=0 then begin Acquire_ArtificialNeuron;  exit; end;
  {*** Injected Current ***}
  data3:= (Icom - Icom_offset)/Icom_scale;
  { Check physiological limits }   // 7.05.2012
  if (V>100{mV})or(V<-150{mV})or
     ((abs(V-Vprev)>20{mV})and(Vprev<>0))or
     (abs(data3)>10) then begin
     data3:=0;
  end;
  {niDAQmx 8.3:}
  data3:=6.13;
  k:=DAQmxWriteAnalogF64(CTask,1,false,10.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);
//feb13  k:=DAQmxWriteAnalogScalarF64(CTask,false,10.0,data3,NIL);
  {niDAQmx 7.4:}
  {  k:=DAQmxWriteAnalogF64(CTask,1,0,    5.0,DAQmx_Val_GroupByChannel,@data3,@wr,NIL);}
  d:=k*0;
  {*** Registered voltage and real current ***}
  Vprev:=V;
  k:=DAQmxReadAnalogF64(ATask,1,10.0,DAQmx_Val_GroupByChannel,@data1,2,@read1,NIL);
//  k:=DAQmxReadAnalogF64(ATask,1000,10.0,DAQmx_Val_GroupByChannel, @data1,4000, @read1,NIL);
//  k:=DAQmxGetErrorString(k,@ttt,buf);
  d:=k*0;
  { Check acquisition limits }   // 7.05.2012
  if (abs(data1[0])>10)or(abs(data1[1])>10) then exit;     // 7.11.2011
  V     :=data1[0]*V_scale + V_offset;
  Ireal :=data1[1]*Ireal_scale + Ireal_offset;
//  Application.ProcessMessages;
end;

end.

