unit Artifacts;

interface

procedure ReadArtifactsParameters;
procedure RealTime_KillArtifacts;

implementation
uses Init_DC,DCUnit1, Acquisition, AcqThread,RealTime,Measurement,MathMyO;

procedure ReadArtifactsParameters;
begin
  AF.KV3:=Vus;
  AF.KI2:=0;
  AF.KV:=Vus;
  AF.V_corr:=Vus;
  AF.tau_f:=0.05{ms};
  AF.dt_:=AcqTime/AF.tau_f;
  AF.alpha:=0.1;
  AF.G2:=DCForm1.DDSpinEdit50.Value;  {nS}
  AF.G1:=-AF.G2;   { Initial value }
end;


procedure RealTime_KillArtifacts;
{ Inputs:    G2, alpha, dt_, V3=V, I2_1=I_real,
  Updated:   KV3, KI2, KV, V_corr, G1  }
const e=0.01; // small value for G1 increment
var  p,q,F,F_dG,KV_1 :double;
begin
  with AF do begin
    { Filtered variables }
    KV3:=KV3 + dt_*(-KV3 + V);
    KI2:=KI2 + dt_*(-KI2 + Ireal);
    { Functional and its derivative }
    p := V  - (1/(G1+e)+1/G2)*Ireal;
    q :=KV3 - (1/(G1+e)+1/G2)*KI2;
    F_dG:= (q + dt_*(-q + KV)-p)*( q + dt_*(-q + KV)-p);
    KV_1:=KV;
    V_corr := V  - (1/G1+1/G2)*Ireal;
    KV     :=KV3 - (1/G1+1/G2)*KI2;
    F:= (KV + dt_*(-KV + KV_1)-V_corr)*( KV + dt_*(-KV + KV_1)-V_corr);
    { Update estimation }
    if F_dG>F then G1:=G1 - e*alpha*F else G1:=G1 + e*alpha*F;
    Arr_Vcorr[i]:=V_corr;  Arr_G1[i]:=G1;
  end;  
end;

end.
