unit CurrentClamp;

interface

procedure ReadCurrenClampParameters;
procedure CC_Define_I_G(time_:double; var I,G,C:double);
function StimCurrent_CC(time_,V_,Vprev_ :double) :double;
procedure RealTime_CurrentClamp;

implementation
uses Init_DC;


procedure ReadCurrenClampParameters;
begin
  N_steps:=1;
  if (CC.T_I=0)and(CC.TypeOfInputIndex in [1..4]) then CC.TypeOfInputIndex:=0;
  if (CC.T_g=0)and(CC.TypeOfInputIndex in [2..3]) then CC.TypeOfInputIndex:=0;
end;

procedure CC_Define_I_G(time_:double; var I,G,C:double);
begin
  I:=0; G:=0; C:=0;
  if (time_>=t_StartStim)and(time_<t_EndStim) then begin
     case CC.TypeOfInputIndex of
     0: begin {'Constant'}
          I:=CC.I_stim;
          G:=CC.g_stim;
          C:=CC.C_stim;
        end;
     1: begin {'I-sin, g-const'}
          I:=CC.I_stim*sin(2*pi/CC.T_I*time_);
          G:=CC.g_stim;
        end;
     2: begin {'I-const, g-cos'}
          I:=CC.I_stim;
          G:=CC.g_stim*(1+cos(2*pi/CC.T_g*time_));
        end;
     3: begin {'I-sin, g-cos'}
          I:=CC.I_stim*   sin(2*pi/CC.T_I*time_);
          G:=CC.g_stim*(1+cos(2*pi/CC.T_g*time_));
        end;
     4: begin {'I-steps, g-const'}
          if sin(2*pi/CC.T_I*time_)<0 then I:=CC.I_stim else I:=0;
          G:=CC.g_stim;
        end;
     end;
  end;
end;

function StimCurrent_CC(time_,V_,Vprev_ :double) :double;
var I_,G_,C_:double;
begin
  CC_Define_I_G(time_,I_,G_,C_);
  if abs(V)<150 then
       StimCurrent_CC:=I_ - G_*(V_-Vus) - C_*(V_-Vprev_)/AcqTime
  else StimCurrent_CC:=0;
end;

procedure RealTime_CurrentClamp;
var V_:double;
    i :integer;
begin
  V_:=V;
  { Delay V }
  if EC.NstepsOfDelayV>0 then begin
     for i:=EC.NstepsOfDelayV-1 downto 0 do EC.V_delayed[i+1]:=EC.V_delayed[i];
     EC.V_delayed[0]:=V;
     V_:=EC.V_delayed[EC.NstepsOfDelayV];
  end;
  Icom:=StimCurrent_CC(time,V_,Vprev);
end;

end.
