unit DCUnit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, CheckLst, XPStyleActnCtrls, ActnList,
  ActnMan, Buttons, StdActns, ToolWin, ActnCtrls, Grids, ValEdit, DBGrids,
  DB;

type
  TDCForm3 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Panel3: TPanel;
    MainMenu1: TMainMenu;
    Options1: TMenuItem;
    DataSource1: TMenuItem;
    Simulaterecordings1: TMenuItem;
    AcquiredatawithDAQcard2: TMenuItem;
    Analysecalibrationfilesimmediately1: TMenuItem;
    Label2: TLabel;
    Open1: TMenuItem;
    DCProject1: TMenuItem;
    Visualizator1: TMenuItem;
    ViewForm5EstimationsFC1: TMenuItem;
    N1: TMenuItem;
    View1: TMenuItem;
    Panel4: TPanel;
    Retreatcalibrationfiles1: TMenuItem;
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure AcquiredatawithDAQcard2Click(Sender: TObject);
    procedure Simulaterecordings1Click(Sender: TObject);
    procedure DCProject1Click(Sender: TObject);
    procedure Visualizator1Click(Sender: TObject);
    procedure ViewForm5EstimationsFC1Click(Sender: TObject);
    procedure Panel4Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Retreatcalibrationfiles1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DCForm3: TDCForm3;

{--------- Table of calibration signals ---------}

type
  TSignal = class(TObject)
     Item :integer;
     tau_I,tau_G,AmplI,AmplG :double;
     Checked :boolean;
     procedure Parameters(Item_:integer;
                          tau_I_,tau_G_,AmplI_,AmplG_:double;
                          Checked_:boolean);
     procedure PrintParameters(iSignal :integer);
     procedure RunTrial;
  end;

var
  Signals  :array[0..100] of TSignal;
  NSignals :integer;
  CalibrationFN :array[1..20] of string;
  CalibrationN :integer;

procedure OpenVisualizator;
procedure FinishCalibration;

implementation
uses DCUnit1,Measurement,Init_DC,Init,Passive,PP_Analysis,
     Unit1,Unit4,Unit5,Reading,Writing,DCUnit4;

{$R *.dfm}

{**** Signals *****************************************************************}
procedure TSignal.Parameters(Item_:integer;
                             tau_I_,tau_G_,AmplI_,AmplG_:double;
                             Checked_:boolean);
begin
  Item:=Item_;
  tau_I:=tau_I_;
  tau_G:=tau_G_;
  AmplI:=AmplI_;
  AmplG:=AmplG_;
  Checked:=Checked_;
end;

procedure TSignal.PrintParameters(iSignal :integer);
var t1 :string;
begin
  t1:='Icom=';
  case Item of
  0: begin
       t1:=t1+FloatToStr(AmplI)+'pA + '+FloatToStr(AmplG)+'nS * (V-Vus)';
     end;
  3: begin
       t1:=t1+FloatToStr(AmplI)+'pA *sin(2 pi/'+FloatToStr(tau_I)+'ms * t) - ';
       t1:=t1+FloatToStr(AmplG)+'nS *(1+cos(2 pi/'+FloatToStr(tau_G)
                                                           +'ms * t))*(V-Vus)';
     end;
  end;
  if iSignal=1 then begin
     DCForm4.CheckListBox1.SelectAll;
     DCForm4.CheckListBox1.DeleteSelected;
     Application.ProcessMessages;
  end;
  DCForm4.CheckListBox1.Items.Add(t1);
  DCForm4.CheckListBox1.Checked[iSignal-1]:=Checked;
end;

procedure TableOfSignalShapes;
var i:integer;
begin
  NSignals:=18;
  for i:=1 to NSignals do Signals[i]:=TSignal.Create;
  { ******************* Table of calibration signals ***************** }
  CalibrationN:=0;
  {                   Item  tau_I  tau_G   AmplI,pA     AmplG,nS  Checked  }
  Signals[ 1].Parameters(0,     0,     0,  PP.G_L*10,          0,  false);
  Signals[ 2].Parameters(0,     0,     0,  PP.G_L*40,   6*PP.G_L,  false);
  Signals[ 3].Parameters(0,     0,     0,  -PP.G_L*5,     PP.G_L,  false);
  Signals[ 4].Parameters(0,     0,     0,          0, 0.5*PP.G_L,  false);
  Signals[ 5].Parameters(0,     0,     0,          0,     PP.G_L,  false);
  Signals[ 6].Parameters(0,     0,     0,          0,   2*PP.G_L,  false);
  Signals[ 7].Parameters(3,    40,    70, PP.G_L*  5,   1*PP.G_L,  false);
  Signals[ 8].Parameters(3,    40,    70, PP.G_L* 20,   2*PP.G_L,  false);
  Signals[ 9].Parameters(3,    40,    70, PP.G_L* 10,     PP.G_L,   true);
  Signals[10].Parameters(3,    30,    50, PP.G_L* 40,   4*PP.G_L,   true);
  Signals[11].Parameters(3,    80,   140, PP.G_L* 10, 0.5*PP.G_L,   true);
  Signals[12].Parameters(3,    80,   140, PP.G_L* 20,   2*PP.G_L,  false);
  Signals[13].Parameters(3,    80,   140, PP.G_L* 60,   4*PP.G_L,   true);
  Signals[14].Parameters(3,    80,   140, PP.G_L*100,  20*PP.G_L,  false);
  Signals[15].Parameters(0,     0,     0,         20,   7*PP.G_L,  false);
  Signals[16].Parameters(0,     0,     0, PP.G_L* 40,-0.8*PP.G_L,  false);
  Signals[17].Parameters(3,    80,   140, PP.G_L* 40,  20*PP.G_L,   true);
  Signals[18].Parameters(3,    80,   140, PP.G_L*100,   2*PP.G_L,   true);
  for i:=1 to NSignals do Signals[i].PrintParameters(i);
end;

procedure Trial(Item :integer; tau_I,tau_G,AmplI,AmplG :double);
var FN :string;
begin
  CalibrationN:=CalibrationN + 1;
  DCForm3.Label1.Caption:=' Status: Calibration: Recording sample '
                         + IntToStr(CalibrationN);
  Application.ProcessMessages;
  DCForm1.ComboBox1.ItemIndex:=Item; // 0 - steps; 3 - I-cos, g-cos
  DCForm1.DDSpinEdit2.Value :=tau_I; {ms}
  DCForm1.DDSpinEdit52.Value:=tau_G; {ms}
  DCForm1.DDSpinEdit1.Value :=AmplI; {pA}
  DCForm1.DDSpinEdit37.Value:=AmplG; {nS}
  {******}
  RunOnce;
  {******}
  { FileName }
  FN:=DCForm1.ListBox1.Items[DCForm1.ListBox1.Items.Count-1];
  CalibrationFN[CalibrationN]:=FN;
  ProvideMinimumRestingTime;
end;

procedure TSignal.RunTrial;
begin
  if Checked then begin
     {**********************************}
     Trial(Item,tau_I,tau_G,AmplI,AmplG);
     {**********************************}
  end;
end;

{******************************************************************************}

procedure MeanGL;
var i,N_ :integer;
    GL_  :double;
begin
  GL_:=0;  N_:=0;
  for i:=1 to N_steps do begin
      if abs(ResultsOfSeries[i].PP.Icom_step)>0.1{pA} then begin
         GL_:=GL_+ ResultsOfSeries[i].PP.Icom_step/
                  (ResultsOfSeries[i].PP.Vstep-ResultsOfSeries[i].PP.Vbg);
         N_:=N_+1;
      end;
  end;
  if GL_>0.1 then DCForm1.DDSpinEdit18.Value:=GL_/N_; {G_L, in nS}
end;

procedure WriteCalibrationFileNames;
var
    i :integer;
    aaa :text;
begin
  assign(aaa,'CalibrationFileNames'); rewrite(aaa);
  for i:=1 to CalibrationN do begin
      writeln(aaa,CalibrationFN[i]);
  end;
  close(aaa);
end;

procedure ReadCalibrationFileNames;
var
    i :integer;
    aaa :text;
begin
  if not(FileExists('CalibrationFileNames')) then exit;
  assign(aaa,'CalibrationFileNames'); reset(aaa);
  i:=0;
  while not(eof(aaa)) do begin
     i:=i+1;
     readln(aaa,CalibrationFN[i]);
  end;
  CalibrationN:=i;
  close(aaa);
end;

{******************************************************************************}
procedure RecordingsForCalibration;
var i :integer;
begin
  DCForm3.Label1.Caption:=' Status: Opening "PassiveProperties" panel';
  Application.ProcessMessages;
  Protocol:=2;  { Passive }
  DCForm1.RadioGroup2.ItemIndex:=Protocol;
  DCForm1.CheckBox16.Checked:=false; // Firing-Clamp
  DCForm1.TabSheet1.Show;
  { *** }
  DCForm3.Label1.Caption:=' Status: Trying to inject current -10pA';
  Application.ProcessMessages;
  DCForm1.DDSpinEdit5.Value:= -10; {pA} // PP.I_min
  DCForm1.DDSpinEdit3.Value:=1000; {ms} // T_end
  i:=0;
  repeat  i:=i+1;
    {***********}
    RunOnce;
    {***********}
    AnalyseTrace;
    {***********}
    if abs(PP.Vstep-PP.Vbg)<10{mV} then begin
       DCForm1.DDSpinEdit5.Value:=DCForm1.DDSpinEdit5.Value-10; {pA} // PP.I_max
       DCForm3.Label1.Caption:=' Status: Trying to inject current'
                            +IntToStr(trunc(DCForm1.DDSpinEdit5.Value))+'pA';
       Application.ProcessMessages;
    end;
  until (abs(PP.Vstep-PP.Vbg)>=10{mV})or(i>=10);
  DCForm1.DDSpinEdit5.Value:=DCForm1.DDSpinEdit5.Value*1.2; // PP.I_min
  DCForm1.DDSpinEdit6.Value:=0; {pA} // PP.I_max
  DCForm1.DDSpinEdit7.Value:=5;      // N_steps
  DCForm1.PointSeries1.Clear;
  DCForm1.TabSheet6.Show;
  { *** }
  DCForm3.Label1.Caption:=' Status: Runing Series';
  Application.ProcessMessages;
  {********}
  RunSeries;
  {********}
  { *** }
  DCForm3.Label1.Caption:=' Status: Estimation of mean G_L';
  Application.ProcessMessages;
  MeanGL;
  DrawLineWithSlope_G;
  ProvideMinimumRestingTime;
  Application.ProcessMessages;
  sleep(4000);
  { *** }
  DCForm3.Label1.Caption:=' Status: Opening "Current-Clamp" panel';
  Application.ProcessMessages;
  Protocol:=1;  { Current-Clamp }
  DCForm1.RadioGroup2.ItemIndex:=Protocol;
  DCForm1.TabSheet5.Show;
  DCForm1.DDSpinEdit10.Value:=800;{ms} // t_EndStim
  { *** }
  DCForm3.Label1.Caption:=' Status: Setting FIRING-CLAMP';
  Application.ProcessMessages;
  DCForm1.CheckBox16.Checked:=true;  // Firing-Clamp
  DCForm1.DDSpinEdit12.Value:=0.6+trunc((PP.G_L-1.2)*2)*0.1; {nA} // FC.PositivePulseCurrent
  DCForm1.DDSpinEdit13.Value:=trunc(10*DCForm1.DDSpinEdit12.Value*3/4)/10; // FC.NegativePulseCurrent
  { Ask user to agree with parameters }
  DCForm1.TabSheet4.Show; // Options
  DCForm4.Visible:=true;
  DCForm4.Top:=DCForm3.Top-480;
  DCForm4.Left:=DCForm1.Left+DCForm1.GroupBox3.Left+DCForm1.GroupBox3.Width+8;
  DCForm4.Label1.Caption:='Estimated input conductance: GL='
                         +FloatToStr(DCForm1.DDSpinEdit18.Value)+' nS.';
  DCForm4.Label2.Caption:='If you agree with FC parameters, then, please,';
  DCForm4.Label3.Caption:='select or deselect proper functions '
                         +'for calibration signals';
  DCForm4.Label4.Caption:='and click OK.';
  {******************}
  TableOfSignalShapes;
  {******************}
  DCForm3.Panel4.Visible:=true;  { OK-button }
  DCForm4.Panel1.Visible:=true;  { OK-button }
end;

procedure RecordingsForCalibration_step2;
var i :integer;
begin
  DCForm1.CheckBox16.Checked:=true;  // Firing-Clamp
  { **************************** Calibration ********************************* }
  CalibrationN:=0;
  for i:=1 to NSignals do Signals[i].RunTrial;
  DCForm3.Label1.Caption:=' Status: Writing calibration file names in a file';
  WriteCalibrationFileNames;
  { ************************************************************************** }
  DCForm3.Label1.Caption:=' Status: Deleting estimation file';
  DeleteFile('I_G_VT_dV_subV_PulseV_PulseDur.dat');
  DCForm1.CheckBox16.Checked:=false;  // Firing-Clamp
  DCForm3.Panel4.Visible:=false;
  DCForm4.Panel4.Visible:=true;
  DCForm3.Label1.Caption:=' Status: End of calibrating recordings.';
  Application.ProcessMessages;
  Sleep(1000);
end;

procedure ChangeOptionsForRecording;
begin
  DCForm3.Label1.Caption:=' Status: Changing Options';
  Application.ProcessMessages;
  DCForm1.DDSpinEdit3.Value:=10000;{ms} // T_end
  DCForm1.ComboBox1.ItemIndex:=0; // I-step
  DCForm1.DDSpinEdit1.Value :=0; {pA} // I_stim
  DCForm1.DDSpinEdit37.Value:=0; {nS} // g_stim
  DCForm1.DDSpinEdit27.Value:=1; {ms} // dt_draw
  DCForm3.Label1.Caption:='Ready for recordings';
  Application.ProcessMessages;
end;

procedure AnalysisForCalibration;
var RootDir :string;
    i,j :integer;
begin
  GetDir(0,RootDir);
  Form1.Show;
  Form1.TabSheet4.Show;
  SetCurrentDir(RootDir);
  Form4.Show;
  ReadListOfFiles;
  DCForm3.Label1.Caption:=' Status: Selecting calibration files in Visualizator window';
  Application.ProcessMessages;
  ReadCalibrationFileNames;
  { Find Calibration files in the whole list and select them }
  for j:=1 to NOfFilesInTheList do begin
      for i:=1 to CalibrationN do begin
          if Form4.ListBox1.Items[j-1]=CalibrationFN[i] then begin
             Form4.ListBox1.Selected[j-1]:=true;
          end;
      end;
  end;
  Application.ProcessMessages;
  Sleep(2000);
  DCForm3.Label1.Caption:=' Status: Calibrating with the selected files';
  PrepareOptionsOfVisualisatorForCalibration;
  {****************}
  TreatFilesInForm4;
  {****************}
  DCForm3.Label1.Caption:=' Status: Un-selecting files';
  for j:=1 to NOfFilesInTheList do begin
      Form4.ListBox1.Selected[j-1]:=true;
  end;
  PrepareOptionsOfVisualisatorForApproximation;
  DCForm3.Label1.Caption:=' Status: Calibration is done.';
  Application.ProcessMessages;
end;

procedure AnalyseRecordingsToEstimate2dInput;
begin
  Form4.ListBox1.Selected[Form4.ListBox1.Items.Count-1]:=true;
  DCForm3.Label1.Caption:=' Status: Analyzing data and estimating input I and G';
  { *** }
  Form4.Show;
  ReadListOfFiles;
  DCForm3.Label1.Caption:=' Status: Selecting the last file in Visualizator window';
  Application.ProcessMessages;
  Form4.ListBox1.Selected[NOfFilesInTheList-1]:=true;
  {****************}
  TreatFilesInForm4;
  {****************}
  DCForm3.Label1.Caption:=' Status: Estimation of input I and G is done.';
end;

{**************** BUTTONS *****************************************************}

procedure TDCForm3.Panel1Click(Sender: TObject);
{ Calibrate - button }
begin
  { Model instead of amplifier }
  if DCForm3.Simulaterecordings1.Checked then DCForm1.ComboBox2.ItemIndex:=0;
  { *** }
  DCForm3.Panel1.Enabled:=false;
  DCForm3.Panel1.Font.Color:=clGray;
  {***********************}
  RecordingsForCalibration;
  {***********************}
  DCForm3.Label1.Caption:='If you agree with FC parameters, click OK:';
  DCForm3.Panel1.Enabled:=true;
  DCForm3.Panel1.Font.Color:=$0080BF90;
end;

procedure FinishCalibration;
begin
  RecordingsForCalibration_step2;
  {***********************}
  ChangeOptionsForRecording;
  {************************}
  if DCForm3.Analysecalibrationfilesimmediately1.Checked then begin
    {**********************}
     AnalysisForCalibration;
    {**********************}
  end;
  DCForm3.Panel1.Enabled:=true;
  DCForm3.Panel1.Font.Color:=$000000D5;
end;

procedure TDCForm3.Panel4Click(Sender: TObject);
{ OK - button to continue calibration }
begin
  {****************}
  FinishCalibration;
  {****************}
end;

procedure TDCForm3.Panel2Click(Sender: TObject);
{ Record - button }
var FName :string;
    j :integer;
begin
  DCForm3.Panel2.Enabled:=false;
  DCForm3.Panel2.Font.Color:=clGray;
  { *** }
  DCForm3.Label1.Caption:=' Status: Read parameters of the last calibration file';
  DCForm1.CheckBox12.Checked:=false; // Don't read parameters from file=false
  DCReadListOfFiles;
  ReadCalibrationFileNames;
  for j:=1 to DC_NOfFilesInTheList do begin
      if DCForm1.ListBox1.Items[j-1]=CalibrationFN[CalibrationN] then begin
         FName:=DCForm1.ListBox1.Items[j-1];
      end;
  end;
  DCReadPastTrace(FName);
  DCForm1.CheckBox12.Checked:=true; // Don't read parameters from file=true
  {************************}
  ChangeOptionsForRecording;
  {************************}
  DCForm3.Label1.Caption:=' Status: Acquiring';
  Application.ProcessMessages;
  {******}
  RunOnce;
  {******}
  DCForm3.Panel2.Enabled:=true;
  DCForm3.Panel2.Font.Color:=$000000D5;
  DCForm3.Label1.Caption:=' Status: Recorded.';
  Application.ProcessMessages;
end;

procedure TDCForm3.Panel3Click(Sender: TObject);
{ Analyse - button }
begin
  DCForm3.Panel3.Enabled:=false;
  DCForm3.Panel3.Font.Color:=clGray;
  if FileExists('I_G_VT_dV_subV_PulseV_PulseDur.dat')=false then begin
    {**********************}
     AnalysisForCalibration;
    {**********************}
  end;
  {*********************************}
  AnalyseRecordingsToEstimate2dInput;
  {*********************************}
  DCForm3.Panel3.Enabled:=true;
  DCForm3.Panel3.Font.Color:=$000000D5;
  Application.ProcessMessages;
end;

procedure TDCForm3.AcquiredatawithDAQcard2Click(Sender: TObject);
begin
  DCForm3.AcquiredatawithDAQcard2.Checked:=true;
end;

procedure TDCForm3.Simulaterecordings1Click(Sender: TObject);
begin
  DCForm3.Simulaterecordings1.Checked:=not(DCForm3.Simulaterecordings1.Checked);
  if DCForm3.Simulaterecordings1.Checked then DCForm1.ComboBox2.ItemIndex:=0;
end;

procedure TDCForm3.DCProject1Click(Sender: TObject);
{ Open DC_Project }
begin
  DCForm1.Show;
//  Form1.Hide;
//  Form4.Hide;
end;

procedure OpenVisualizator;
{ Open Visualizator }
begin
  Form1.Show;
  Form4.Show;
//  DCForm1.Hide;
  SetCurrentDir(DirOfTheProgram);
  GetDir(0,RootDir);
  Form1.ComboBox1.Items.Add(RootDir);
  Form1.ComboBox1.ItemIndex:=Form1.ComboBox1.Items.Count-1;
  if Form1.ComboBox2.ItemIndex=2 {Umea} then ReadListOfFiles;
end;

procedure TDCForm3.Visualizator1Click(Sender: TObject);
begin
  OpenVisualizator;
end;

procedure TDCForm3.ViewForm5EstimationsFC1Click(Sender: TObject);
{ Open Form5 - Estimations }
begin
  Form1.Show;
  Form4.Show;
  Form5.Show;
//  DCForm1.Hide;
  SetCurrentDir(DirOfTheProgram);
  if Form1.ComboBox2.ItemIndex=2 {Umea} then ReadListOfFiles;
end;

procedure TDCForm3.View1Click(Sender: TObject);
{ Open DCForm4 - Estimation table }
begin
  DCForm4.Show;
end;

procedure TDCForm3.Retreatcalibrationfiles1Click(Sender: TObject);
begin
 DeleteFile('I_G_VT_dV_subV_PulseV_PulseDur.dat');
end;

end.
