program DC_Project;

uses
  Forms,
  DCUnit1 in 'DCUnit1.pas' {DCForm1 - DC-Acquisition Program},
  DCUnit2 in 'DCUnit2.pas' {DCForm2 - log-file},
  DCUnit3 in 'DCUnit3.pas' {DCForm3 - Firing-Clamp, all-in-one},
  DCUnit4 in 'DCUnit4.pas' {DCForm4 - Parameters of calibration signals},
  DCUnit9 in 'DCUnit9.pas' {DCForm9 - Patching},
  Acquisition in 'Acquisition.pas',
  AcqThread in 'AcqThread.pas',
  Artifacts in 'Artifacts.pas',
  ArtMode in 'ArtMode.pas',
  CurrentClamp in 'CurrentClamp.pas',
  Dynamic_VC in 'Dynamic_VC.pas',
  FiringClamp in 'FiringClamp.pas',
  Init_DC in 'Init_DC.pas',
  Measurement in 'Measurement.pas',
  Na_and_K in 'Na_and_K.pas',
  NoiseO in 'NoiseO.pas',
  OnlineComp in 'OnlineComp.pas',
  Passive in 'Passive.pas',
  PP_Analysis in 'PP_Analysis.pas',
  ReadWrite_pars in 'ReadWrite_pars.pas',
  RealTime in 'RealTime.pas',
  SMOCs in 'SMOCs.pas',
  Tongue in 'Tongue.pas',
  ThresholdClamp in 'ThresholdClamp.pas',
  Writing in 'Writing.pas',
  ADPO in '_ObjectsOfNeuron\ADPO.pas',
  AHPO in '_ObjectsOfNeuron\AHPO.pas',
  Bazh_NaO in '_ObjectsOfNeuron\Bazh_NaO.pas',
  Bazh_NaRO in '_ObjectsOfNeuron\Bazh_NaRO.pas',
  Bazh_KO in '_ObjectsOfNeuron\Bazh_KO.pas',
  BstO in '_ObjectsOfNeuron\BstO.pas',
  Calmar_KO in '_ObjectsOfNeuron\Calmar_KO.pas',
  Calmar_NaO in '_ObjectsOfNeuron\Calmar_NaO.pas',
  Calmar_NaRO in '_ObjectsOfNeuron\Calmar_NaRO.pas',
  ChannelO in '_ObjectsOfNeuron\ChannelO.pas',
  Chow_NaO in '_ObjectsOfNeuron\Chow_NaO.pas',
  Chow_NaRO in '_ObjectsOfNeuron\Chow_NaRO.pas',
  Chow_KO in '_ObjectsOfNeuron\Chow_KO.pas',
  CondBasedO in '_ObjectsOfNeuron\CondBasedO.pas',
  CreateNrnO in '_ObjectsOfNeuron\CreateNrnO.pas',
  Cum_CaHO in '_ObjectsOfNeuron\Cum_CaHO.pas',
  Cum_CaTO in '_ObjectsOfNeuron\Cum_CaTO.pas',
  Cum_KAO in '_ObjectsOfNeuron\Cum_KAO.pas',
  Cum_KDO in '_ObjectsOfNeuron\Cum_KDO.pas',
  Cum_KO in '_ObjectsOfNeuron\Cum_KO.pas',
  Cum_NaO in '_ObjectsOfNeuron\Cum_NaO.pas',
  Cum_NaRO in '_ObjectsOfNeuron\Cum_NaRO.pas',
  Dest_CaTO in '_ObjectsOfNeuron\Dest_CaTO.pas',
  Dest_CaHO in '_ObjectsOfNeuron\Dest_CaHO.pas',
  Dest_KCaO in '_ObjectsOfNeuron\Dest_KCaO.pas',
  Dest_KMO in '_ObjectsOfNeuron\Dest_KMO.pas',
  Dest_KO in '_ObjectsOfNeuron\Dest_KO.pas',
  Fleid_NaO in '_ObjectsOfNeuron\Fleid_NaO.pas',
  KepecsWang_KCaO in '_ObjectsOfNeuron\KepecsWang_KCaO.pas',
  Konon_NaPO in '_ObjectsOfNeuron\Konon_NaPO.pas',
  LIFNrnO in '_ObjectsOfNeuron\LIFNrnO.pas',
  Lyle_HO in '_ObjectsOfNeuron\Lyle_HO.pas',
  Lyle_KAO in '_ObjectsOfNeuron\Lyle_KAO.pas',
  Lyle_KDO in '_ObjectsOfNeuron\Lyle_KDO.pas',
  Lyle_KMO in '_ObjectsOfNeuron\Lyle_KMO.pas',
  Lyle_KO in '_ObjectsOfNeuron\Lyle_KO.pas',
  Lyle_NaO in '_ObjectsOfNeuron\Lyle_NaO.pas',
  Lyle_NaRO in '_ObjectsOfNeuron\Lyle_NaRO.pas',
  Lyle_NaPO in '_ObjectsOfNeuron\Lyle_NaPO.pas',
  LyleMS_NaRO in '_ObjectsOfNeuron\LyleMS_NaRO.pas',
  LyleMS_NaO in '_ObjectsOfNeuron\LyleMS_NaO.pas',
  MathMyO in '_ObjectsOfNeuron\MathMyO.pas',
  Migli_KAO in '_ObjectsOfNeuron\Migli_KAO.pas',
  Migli_KO in '_ObjectsOfNeuron\Migli_KO.pas',
  Migli_NaO in '_ObjectsOfNeuron\Migli_NaO.pas',
  Migli_NaRO in '_ObjectsOfNeuron\Migli_NaRO.pas',
  Milescu_NaO in '_ObjectsOfNeuron\Milescu_NaO.pas',
  Milescu_NaRO in '_ObjectsOfNeuron\Milescu_NaRO.pas',
  Naundorf_KO in '_ObjectsOfNeuron\Naundorf_KO.pas',
  Naundorf_NaO in '_ObjectsOfNeuron\Naundorf_NaO.pas',
  Naundorf_NaO1 in '_ObjectsOfNeuron\Naundorf_NaO1.pas',
  NeuronO in '_ObjectsOfNeuron\NeuronO.pas',
  NullChannelO in '_ObjectsOfNeuron\NullChannelO.pas',
  Shu_NaO in '_ObjectsOfNeuron\Shu_NaO.pas',
  Shu_NaRO in '_ObjectsOfNeuron\Shu_NaRO.pas',
  Shu_KO in '_ObjectsOfNeuron\Shu_KO.pas',
  SetNrnParsO in '_ObjectsOfNeuron\SetNrnParsO.pas',
  typeNrnParsO in '_ObjectsOfNeuron\typeNrnParsO.pas',
  ThreshNrnO in '_ObjectsOfNeuron\ThreshNrnO.pas',
  t_dtO in '_ObjectsOfNeuron\t_dtO.pas',
  ThresholdO in '_ObjectsOfNeuron\ThresholdO.pas',
  White_AHPO in '_ObjectsOfNeuron\White_AHPO.pas',
  White_CaO in '_ObjectsOfNeuron\White_CaO.pas',
  White_KO in '_ObjectsOfNeuron\White_KO.pas',
  White_NaO in '_ObjectsOfNeuron\White_NaO.pas',
  White2_NaO in '_ObjectsOfNeuron\White2_NaO.pas',
  HHUnit18 in '_ObjectsOfNeuron\HHUnit18.pas' {HHForm18},
  AnalyzeFC in 'Visualizator\AnalyzeFC.pas',
  Analyzer in 'Visualizator\Analyzer.pas',
  ApproximateFC in 'Visualizator\ApproximateFC.pas',
  Compensation in 'Visualizator\Compensation.pas',
  EstimateFC in 'Visualizator\EstimateFC.pas',
  ExtracelStim in 'Visualizator\ExtracelStim.pas',
  Init in 'Visualizator\Init.pas',
  main in 'Visualizator\main.pas',
  MathMy in 'Visualizator\MathMy.pas',
  Reading in 'Visualizator\Reading.pas',
  Statistics in 'Visualizator\Statistics.pas',
  Unit1 in 'Visualizator\Unit1.pas' {Form1 - Visualizator},
  Unit2 in 'Visualizator\Unit2.pas' {Form2},
  Unit3 in 'Visualizator\Unit3.pas' {Form3},
  Unit4 in 'Visualizator\Unit4.pas' {Form4 - List of files},
  Unit5 in 'Visualizator\Unit5.pas' {Form5 - Estimations_FC},
  Unit6 in 'Visualizator\Unit6.pas' {Form6 - current},
  Unit7 in 'Visualizator\Unit7.pas' {Form7 - Warnings},
  Unit13 in 'Visualizator\Unit13.pas' {Form13 - Statistics},
  FrameLattice in 'FrameLattice.pas' {FrameLattice: TFrame},
  Unit8 in 'Visualizator\Unit8.pas' {Form8 - Lyle estimation};

{$R *.res}

begin
  Application.Initialize;
  Application.CreateForm(TDCForm1, DCForm1);
  Application.CreateForm(TDCForm2, DCForm2);
  Application.CreateForm(TDCForm3, DCForm3);
  Application.CreateForm(THHForm18, HHForm18);
  Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TForm2, Form2);
  Application.CreateForm(TForm3, Form3);
  Application.CreateForm(TForm4, Form4);
  Application.CreateForm(TForm5, Form5);
  Application.CreateForm(TForm6, Form6);
  Application.CreateForm(TForm7, Form7);
  Application.CreateForm(TForm13, Form13);
  Application.CreateForm(TDCForm4, DCForm4);
  Application.CreateForm(TForm8, Form8);
  Application.CreateForm(TDCForm9, DCForm9);
  Application.Run;
end.
