unit Dynamic_VC;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls, ComCtrls;

procedure Read_DynVC_Parameters;
procedure ReturnSettingsForCurrentClampProtocols;
procedure RealTime_DynVC;

implementation
uses Init_DC,DCUnit1, Acquisition, AcqThread,RealTime,Measurement,MathMyO;

var
    Icom_offset_mem,V_offset_mem,V_scale_mem,Icom_scale_mem,Ireal_scale_mem,
    Vmin_mem,Vmax_mem,dVmax_mem
                                                                :double;
    ChBx4_mem                                                   :boolean;

procedure Read_DynVC_Parameters;
begin
  DynVC.VL :=DCForm1.DDSpinEdit73.Value; {mV}
  DynVC.Vh0:=DCForm1.DDSpinEdit74.Value; {mV}
  DynVC.k  :=DCForm1.DDSpinEdit79.Value;
  DynVC.I_scale    :=DCForm1.DDSpinEdit76.Value; {pA/V}      //V_scale
  DynVC.Vh_scale   :=DCForm1.DDSpinEdit77.Value; {mV/V}      //Icom_scale
  DynVC.Vreal_scale:=DCForm1.DDSpinEdit78.Value; {mV/V}
  DynVC.I_offset   :=DCForm1.DDSpinEdit75.Value; {pA}
  { Plotting settings }
  DCForm1.LineSeries2.ParentChart:=DCForm1.Chart1;  // V    to bottom chart
  DCForm1.LineSeries4.ParentChart:=DCForm1.Chart2;  // Icom to top chart
  DCForm1.LineSeries6.ParentChart:=DCForm1.Chart2;  // Ireal to top chart
  DCForm1.LineSeries2.Title:='I from VC'; // V
  DCForm1.LineSeries4.Title:='Vh for VC'; // Icom
  DCForm1.LineSeries6.Title:='Vreal for VC'; // Ireal
  ChBx4_mem:=DCForm1.CheckBox4.Checked;   // Show command I and G
  DCForm1.CheckBox4.Checked:=false;
  Icom_offset_mem:=Icom_offset;  Icom_offset:=0{DynVC.Vh0};
  V_offset_mem   :=V_offset;     V_offset   :=DynVC.I_offset;
  Icom_scale_mem :=Icom_scale;   Icom_scale :=DynVC.Vh_scale;
  V_scale_mem    :=V_scale;      V_scale    :=DynVC.I_scale;
  Ireal_scale_mem:=Ireal_scale;  Ireal_scale:=DynVC.Vreal_scale;
  Vmin_mem :=Vmin;    Vmin:=-10*V_scale;
  Vmax_mem :=Vmax;    Vmax:= 10*V_scale;
  dVmax_mem:=dVmax;   dVmax:=1e6;
  { Initial conditions }
  DynVC.Vh:=DynVC.Vh0;
  Application.ProcessMessages;
end;

procedure ReturnSettingsForCurrentClampProtocols;
begin
  { Plotting settings }
  DCForm1.LineSeries2.ParentChart:=DCForm1.Chart2;  // V    to top chart
  DCForm1.LineSeries4.ParentChart:=DCForm1.Chart1;  // Icom to bottom chart
  DCForm1.LineSeries6.ParentChart:=DCForm1.Chart1;  // Ireal to bottom chart
  DCForm1.LineSeries2.Title:='V';        // V
  DCForm1.LineSeries4.Title:='Icom';     // Icom
  DCForm1.LineSeries6.Title:='Ireal';    // Ireal
  DCForm1.CheckBox4.Checked:=ChBx4_mem;  // Show command I and G
  Icom_offset:=Icom_offset_mem;
  V_offset   :=V_offset_mem;
  V_scale    :=V_scale_mem;
  Icom_scale :=Icom_scale_mem;
  Ireal_scale:=Ireal_scale_mem;
  Vmin :=Vmin_mem;
  Vmax :=Vmax_mem;
  dVmax:=dVmax_mem;
  Application.ProcessMessages;
end;

procedure RealTime_DynVC;
{ Model is    -GL*(V-VL) - GI*(V-VI) + I = 0.
  Zero inhibitory current is provided if  V=VL+I/GL. }
var dVh :double;
begin
  if PP.G_L=0 then exit;
  Vprev:=V;
  DynVC.I:=V;  // renaming
  if (time>=t_StartStim)and(time<t_EndStim) then begin
     if (time>300)and(time<=300.05) then begin
             DynVC.Vh:=DynVC.Vh +0;
     end;
     {*** Model ****************************************}
     dVh:=DynVC.Vh-DynVC.VL - DynVC.I/PP.G_L;   // "-" is new
     DynVC.Vh := DynVC.Vh + dVh*DynVC.k;
     {**************************************************}
  end else begin
     DynVC.Vh:=DynVC.Vh0;
  end;
  Icom:=DynVC.Vh; //renaming
end;

end.
