unit OnlineComp;

interface
uses DCUnit1,Init_DC;

procedure ReadElectrodeCompensationParameters;
procedure RealTime_ElectrodeCompensation;

implementation


procedure ReadElectrodeCompensationParameters;
var  i :integer;
begin
  EC.G1:=DCForm1.DDSpinEdit56.Value {nS}; //electrode conductance;
  EC.Ireal_prev:=0;
  EC.Ireal_pprev:=0;
  EC.tau_Vfilt:=DCForm1.DDSpinEdit57.Value; {ms}
  EC.tau_Ifilt:=DCForm1.DDSpinEdit58.Value; {ms}
  EC.I_filt:=0;
  EC.V_filt:=Vus;
  EC.Ireal_Or_Icom:=DCForm1.ComboBox7.ItemIndex+1;
  EC.NstepsOfDelayV:=trunc(DCForm1.DDSpinEdit67.Value);
  for i:=0 to EC.NstepsOfDelayV do EC.V_delayed[i]:=0;
end;

procedure RealTime_ElectrodeCompensation;
var nt_,i :integer;
    dVseries_,I_  :double;
begin
  case EC.Ireal_Or_Icom of
  1: I_:=Ireal;
  2: I_:=Icom;
  end;
  { Filter V }
  if EC.tau_Vfilt>0 then begin
     EC.V_filt:=EC.V_filt+AcqTime/EC.tau_Vfilt*(V-EC.V_filt);
     V:=EC.V_filt;
  end;
  if EC.G1=0 then exit;
  { Filter Ireal }
  if EC.tau_Ifilt>0 then begin
     EC.I_filt:=EC.I_filt+AcqTime/EC.tau_Ifilt*(I_-EC.I_filt);
     dVseries_:=EC.I_filt/EC.G1;
  end else begin
     dVseries_:=EC.Ireal_prev/EC.G1;
  end;
  if abs(dVseries_)<50{mV} then begin
     {* Voltage correction *}
     V := V - dVseries_;
     {**********************}
  end;
  EC.Ireal_pprev:=EC.Ireal_prev;
  EC.Ireal_prev:=I_;
end;

end.

