unit PP_Analysis;

interface

procedure ReadPassiveParameters;
procedure PP_Define_I_G(time_:double; var I,G,C:double);
procedure RealTime_Passive;
procedure DrawLineWithSlope_G;
procedure DrawExponentialFit_taum;
procedure AnalysePassive;

implementation
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart, DDSpinEdit, ComCtrls, Menus,
  Init_DC,DCUnit1, Acquisition, AcqThread,RealTime,Measurement;


procedure ReadPassiveParameters;
begin
  N_steps:=PP.N_steps;
  i_end:=trunc(1000{ms}/AcqTime);
end;

procedure PP_Define_I_G(time_:double; var I,G,C:double);
begin
  I:=0; G:=0; C:=0;
  if (time_>=t_StartStim)and(time_<t_EndStim) then begin
      I:=PP.I_min+(PP.I_max-PP.I_min)/(PP.N_steps-1)*(i_step-1);
  end;
end;

procedure RealTime_Passive;
var I_,G_,C_:double;
begin
  PP_Define_I_G(time,I_,G_,C_);
  Icom:=I_;
{  if (time>=t_StartStim)and(time<t_EndStim) then begin
      Icom:=PP.I_min+(PP.I_max-PP.I_min)/(PP.N_steps-1)*(i_step-1);
  end else begin
      Icom:=0;
  end;}
end;

procedure DrawLineWithSlope_G;
begin
  PP.G_L:=DCForm1.DDSpinEdit18.Value; {nS}
  DCForm1.LineSeries1.Clear;
  if PP.G_L>0 then begin
     DCForm1.LineSeries1.AddXY(-100,-100/PP.G_L);
     DCForm1.LineSeries1.AddXY( 100, 100/PP.G_L);
  end;
  Application.ProcessMessages;
end;

//var   Vbg,Vstep,Icom_step :double;

procedure DrawExponentialFit_taum;
var i,istart :integer;
    Vexponent :double;
begin
  PP.tau_m:=DCForm1.DDSpinEdit54.Value; {ms}
  if (AcqTime=0) or (PP.tau_m=0) then exit;
  istart:=trunc(t_StartStim/AcqTime);
  DCForm1.Series14.Clear;
  DCForm1.Series15.Clear;
  for i:=istart-trunc(20{ms}/AcqTime) to istart+trunc(10*PP.tau_m/AcqTime) do begin
      if (i*AcqTime<=t_StartStim) then Vexponent:=PP.Vbg else
      Vexponent:=PP.Vbg
                +(PP.Vstep-PP.Vbg)*(1-exp(-(i*AcqTime-t_StartStim)/PP.tau_m));
      DCForm1.Series14.AddXY(i*AcqTime,Arr_V[i]);
      DCForm1.Series15.AddXY(i*AcqTime,Vexponent);
  end;
  Application.ProcessMessages;
end;

procedure AnalysePassive;
var k1,k2 :integer;
begin
  k1:=0;  k2:=0;
  i:=-1;
  repeat    i:=i+1;
    V:=Arr_V[i]; Ireal:=Arr_Ireal[i]; Icom:=Arr_Icom[i]; time:=Arr_t[i];
    if (time>=PP.t1_start)and(time<PP.t1_end) then begin
        k1:=k1+1;
        PP.Vbg:=PP.Vbg*(k1-1)/k1 + V/k1;
    end;
    if (time>=PP.t2_start)and(time<PP.t2_end) then begin
        k2:=k2+1;
        PP.Vstep:=PP.Vstep*(k2-1)/k2 + V/k2;
        PP.Icom_step:=Icom;
    end;
  until i>=i_end;
  DCForm1.PointSeries1.AddXY(PP.Icom_step,PP.Vstep-PP.Vbg);
  DrawLineWithSlope_G;
  DrawExponentialFit_taum;
  Application.ProcessMessages;
end;

end.
