unit ReadWrite_pars;

interface
uses Init_DC{,Na_and_K},SysUtils;

procedure WriteParametersTo(FName_Params :string);
procedure ReadParametersOf(FName_Params :string);

implementation

procedure WriteParametersTo(FName_Params :string);
var ccc :text;
begin
  assign(ccc,FName_Params); rewrite(ccc);
  writeln(ccc,'T_end=');        writeln(ccc,'            ',T_end:10:3,' ');
  writeln(ccc,'i_end=');        writeln(ccc,'            ',i_end:13,' ');
  writeln(ccc,'AcqTime=');      writeln(ccc,'            ',AcqTime:10:3,' ');
  writeln(ccc,'t_StartStim=');  writeln(ccc,'            ',t_StartStim:10:3,' ');
  writeln(ccc,'t_EndStim=');    writeln(ccc,'            ',t_EndStim:10:3,' ');
  writeln(ccc,'V_scale=');      writeln(ccc,'            ',V_scale:10:3,' ');
  writeln(ccc,'Icom_scale=');   writeln(ccc,'            ',Icom_scale:10:3,' ');
  writeln(ccc,'Ireal_scale=');  writeln(ccc,'            ',Ireal_scale:10:3,' ');
  writeln(ccc,'V_offset=');     writeln(ccc,'            ',V_offset:10:3,' ');
  writeln(ccc,'Icom_offset=');  writeln(ccc,'            ',Icom_offset:10:3,' ');
  writeln(ccc,'Ireal_offset='); writeln(ccc,'            ',Ireal_offset:10:3,' ');
  writeln(ccc,'dt_draw=');      writeln(ccc,'            ',dt_draw:10:3,' ');
  writeln(ccc,'Epoch=');        writeln(ccc,'            ',Epoch:10:3,' ');
  writeln(ccc,'PP.I_min=');        writeln(ccc,'            ',PP.I_min:13:3,' ');
  writeln(ccc,'PP.I_max=');        writeln(ccc,'            ',PP.I_max:13:3,' ');
  writeln(ccc,'PP.N_steps=');      writeln(ccc,'            ',PP.N_steps:3,' ');
  writeln(ccc,'PP.t1_start=');     writeln(ccc,'            ',PP.t1_start:10:3,' ');
  writeln(ccc,'PP.t1_end=');       writeln(ccc,'            ',PP.t1_end:10:3,' ');
  writeln(ccc,'PP.t2_start=');     writeln(ccc,'            ',PP.t2_start:10:3,' ');
  writeln(ccc,'PP.t2_end=');       writeln(ccc,'            ',PP.t2_end:10:3,' ');
  writeln(ccc,'PP.G_L=');          writeln(ccc,'            ',PP.G_L:10:3,' ');
  writeln(ccc,'US.u_min=');        writeln(ccc,'            ',US.u_min:10:3,' ');
  writeln(ccc,'US.u_max=');        writeln(ccc,'            ',US.u_max:10:3,' ');
  writeln(ccc,'US.s_min=');        writeln(ccc,'            ',US.s_min:10:3,' ');
  writeln(ccc,'US.s_max=');        writeln(ccc,'            ',US.s_max:10:3,' ');
  writeln(ccc,'US.Nu_steps=');     writeln(ccc,'            ',US.Nu_steps:3,' ');
  writeln(ccc,'US.Ns_steps=');     writeln(ccc,'            ',US.Ns_steps:3,' ');
  writeln(ccc,'CC.I_stim=');       writeln(ccc,'            ',CC.I_stim:13:3,' ');
  writeln(ccc,'CC.g_stim=');       writeln(ccc,'            ',CC.g_stim:10:3,' ');
  writeln(ccc,'CC.T_I=');          writeln(ccc,'            ',CC.T_I:10:3,' ');
  writeln(ccc,'Protocol=');     writeln(ccc,'            ',Protocol:3,' ');
  writeln(ccc,'If_ThresholdClamp='); writeln(ccc,'       ',If_ThresholdClamp:3);
  writeln(ccc,'If_FiringClamp=');    writeln(ccc,'       ',If_FiringClamp:3);
  writeln(ccc,'If_KillArtifacts=');  writeln(ccc,'       ',If_KillArtifacts:3);
  writeln(ccc,'Vus=');          writeln(ccc,'            ',Vus:10:3);
  writeln(ccc,'TC.FixedThreshold='); writeln(ccc,'       ',TC.FixedThreshold:10:3);
  writeln(ccc,'TC.CurrentPulseAmplitude='); writeln(ccc,'       ',TC.CurrentPulseAmplitude:13:3);
  writeln(ccc,'TC.CurrentPulseDuration=');  writeln(ccc,'       ',TC.CurrentPulseDuration:10:3);
  writeln(ccc,'TC.MinISI=');    writeln(ccc,'           ',TC.MinISI:10:3);
  writeln(ccc,'FC_online.rate=');      writeln(ccc,'           ',FC.rate:10:3);
  writeln(ccc,'FC_online.Vmin=');      writeln(ccc,'           ',FC.Vmin:10:3);
  writeln(ccc,'FC_online.PositivePulseCurrent=');      writeln(ccc,'       ',FC.PositivePulseCurrent:13:3);
  writeln(ccc,'FC_online.NegativePulseCurrent=');      writeln(ccc,'       ',FC.NegativePulseCurrent:13:3);
  writeln(ccc,'FC_online.PositivePulseDuration=');     writeln(ccc,'       ',FC.PositivePulseDuration:10:3);
  writeln(ccc,'SMOC.tau_raise=');      writeln(ccc,'           ',SMOC.tau_raise:10:3);
  writeln(ccc,'SMOC.tau_decay=');      writeln(ccc,'           ',SMOC.tau_decay:10:3);
  writeln(ccc,'SMOC.g_max=');   writeln(ccc,'           ',SMOC.g_max:10:3);
  writeln(ccc,'SMOC.V_rev=');   writeln(ccc,'           ',SMOC.V_rev:10:3);
  writeln(ccc,'SMOC.rate=');    writeln(ccc,'           ',SMOC.rate:10:3);
  writeln(ccc,'SMOC.al=');      writeln(ccc,'           ',SMOC.al:10:3);
  writeln(ccc,'SMOC.be=');      writeln(ccc,'           ',SMOC.be:10:3);
  writeln(ccc,'SMOC.OrderOfKinetics=');         writeln(ccc,'           ',SMOC.OrderOfKinetics:3);
  writeln(ccc,'SMOC.IfPoisson=');      writeln(ccc,'           ',SMOC.IfPoisson:3);
  writeln(ccc,'CC.T_g=');              writeln(ccc,'            ',CC.T_g:10:3,' ');
  writeln(ccc,'CC.TypeOfInputIndex='); writeln(ccc,'            ',CC.TypeOfInputIndex:3,' ');
  writeln(ccc,'CC.C_stim=');           writeln(ccc,'            ',CC.C_stim:10:3,' ');
  writeln(ccc,'PP.tau_m=');            writeln(ccc,'            ',PP.tau_m:10:3,' ');
  writeln(ccc,'US.t_StartStim_u=');    writeln(ccc,'            ',US.t_StartStim_u:10:3,' ');
  writeln(ccc,'US.t_EndStim_u=');      writeln(ccc,'            ',US.t_EndStim_u:10:3,' ');
  writeln(ccc,'US.t_StartStim_s=');    writeln(ccc,'            ',US.t_StartStim_s:10:3,' ');
  writeln(ccc,'US.t_EndStim_s=');      writeln(ccc,'            ',US.t_EndStim_s:10:3,' ');
  writeln(ccc,'US.T_pause=');          writeln(ccc,'            ',US.T_pause:10:3,' ');
  writeln(ccc,'EC.G1=');               writeln(ccc,'            ',EC.G1:10:3,' ');
  writeln(ccc,'DeviceNumber=');        writeln(ccc,'            ',DeviceNumber:3,' ');
  writeln(ccc,'If_CondCompensation='); writeln(ccc,'            ',If_CondCompensation:3);
  writeln(ccc,'EC.tau_Vfilt=');        writeln(ccc,'            ',EC.tau_Vfilt:10:3,' ');
  writeln(ccc,'EC.tau_Ifilt=');        writeln(ccc,'            ',EC.tau_Ifilt:10:3,' ');
  writeln(ccc,'If_NaAndK=');           writeln(ccc,'            ',If_NaAndK:3);
  writeln(ccc,'NaK.gNaP=');            writeln(ccc,'            ',NaK.gNaP:10:3,' ');
  writeln(ccc,'NaK.gNa=');             writeln(ccc,'            ',NaK.gNa:10:3,' ');
  writeln(ccc,'NaK.gK=');              writeln(ccc,'            ',NaK.gK:10:3,' ');
  writeln(ccc,'NaK.g_GJ=');            writeln(ccc,'            ',NaK.g_GJ:10:3,' ');
  writeln(ccc,'NaK.Vshift=');          writeln(ccc,'            ',NaK.Vshift:10:3,' ');
  writeln(ccc,'NaK.TypeOfModNrn=');           writeln(ccc,NaK.TypeOfModNrn);
  writeln(ccc,'NaK.TypeOfExpNrn=');           writeln(ccc,NaK.TypeOfExpNrn);
  writeln(ccc,'NaK.IfTurnOnModelNeuron=');    writeln(ccc,'     ',NaK.IfTurnOnModelNeuron:3);
  writeln(ccc,'NaK.IfIncludeVrestInVshift='); writeln(ccc,'     ',NaK.IfIncludeVrestInVshift:3);
  writeln(ccc,'NaK.gAHP=');            writeln(ccc,'            ',NaK.gAHP:10:3,' ');
  writeln(ccc,'DynVC.I_scale=');       writeln(ccc,'            ',DynVC.I_scale:10:3,' ');
  writeln(ccc,'DynVC.Vh_scale=');      writeln(ccc,'            ',DynVC.Vh_scale:10:3,' ');
  writeln(ccc,'DynVC.Vreal_scale=');   writeln(ccc,'            ',DynVC.Vreal_scale:10:3,' ');
  writeln(ccc,'DynVC.I_offset=');      writeln(ccc,'            ',DynVC.I_offset:10:3,' ');
  writeln(ccc,'DynVC.VL=');            writeln(ccc,'            ',DynVC.VL:10:3,' ');
  writeln(ccc,'DynVC.Vh0=');           writeln(ccc,'            ',DynVC.Vh0:10:3,' ');
  writeln(ccc,'DynVC.k=');             writeln(ccc,'            ',DynVC.k:10:3,' ');
  writeln(ccc,'Vmin=');                writeln(ccc,'            ',Vmin:10:3,' ');
  writeln(ccc,'Vmax=');                writeln(ccc,'            ',Vmax:10:3,' ');
  writeln(ccc,'dVmax=');               writeln(ccc,'            ',dVmax:10:3,' ');
  close(ccc);
end;

procedure ReadParametersOf(FName_Params :string);
var ccc :text;
    dum :double;
begin
  if not(FileExists(FName_Params)) then exit;
  assign(ccc,FName_Params);  reset(ccc);
  readln(ccc); readln(ccc,T_end);
  readln(ccc); readln(ccc,i_end);
  readln(ccc); readln(ccc,AcqTime);
  readln(ccc); readln(ccc,t_StartStim);
  readln(ccc); readln(ccc,t_EndStim);
  readln(ccc); readln(ccc,V_scale);
  readln(ccc); readln(ccc,Icom_scale);
  readln(ccc); readln(ccc,Ireal_scale);
  readln(ccc); readln(ccc,V_offset);
  readln(ccc); readln(ccc,Icom_offset);
  readln(ccc); readln(ccc,Ireal_offset);
  readln(ccc); readln(ccc,dum{dt_draw});
  readln(ccc); readln(ccc,Epoch);
  readln(ccc); readln(ccc,PP.I_min);
  readln(ccc); readln(ccc,PP.I_max);
  readln(ccc); readln(ccc,PP.N_steps);
  readln(ccc); readln(ccc,PP.t1_start);
  readln(ccc); readln(ccc,PP.t1_end);
  readln(ccc); readln(ccc,PP.t2_start);
  readln(ccc); readln(ccc,PP.t2_end);
  readln(ccc); readln(ccc,PP.G_L);
  readln(ccc); readln(ccc,US.u_min);
  readln(ccc); readln(ccc,US.u_max);
  readln(ccc); readln(ccc,US.s_min);
  readln(ccc); readln(ccc,US.s_max);
  readln(ccc); readln(ccc,US.Nu_steps);
  readln(ccc); readln(ccc,US.Ns_steps);
  readln(ccc); readln(ccc,CC.I_stim);
  readln(ccc); readln(ccc,CC.g_stim);
  readln(ccc); readln(ccc,CC.T_I);
  readln(ccc); readln(ccc,Protocol);
  readln(ccc); readln(ccc,If_ThresholdClamp);
  readln(ccc); readln(ccc,If_FiringClamp);
  readln(ccc); readln(ccc,If_KillArtifacts);
  readln(ccc); readln(ccc,Vus);
  readln(ccc); readln(ccc,TC.FixedThreshold);
  readln(ccc); readln(ccc,TC.CurrentPulseAmplitude);
  readln(ccc); readln(ccc,TC.CurrentPulseDuration);
  readln(ccc); readln(ccc,TC.MinISI);
  readln(ccc); readln(ccc,FC.rate);
  readln(ccc); readln(ccc,FC.Vmin);
  readln(ccc); readln(ccc,FC.PositivePulseCurrent);
  readln(ccc); readln(ccc,FC.NegativePulseCurrent);
  readln(ccc); readln(ccc,FC.PositivePulseDuration);
  readln(ccc); readln(ccc,SMOC.tau_raise);
  readln(ccc); readln(ccc,SMOC.tau_decay);
  readln(ccc); readln(ccc,SMOC.g_max);
  readln(ccc); readln(ccc,SMOC.V_rev);
  readln(ccc); readln(ccc,SMOC.rate);
  readln(ccc); readln(ccc,SMOC.al);
  readln(ccc); readln(ccc,SMOC.be);
  readln(ccc); readln(ccc,SMOC.OrderOfKinetics);
  readln(ccc); readln(ccc,SMOC.IfPoisson);
  readln(ccc); readln(ccc,CC.T_g);
  readln(ccc); if not eof(ccc) then readln(ccc,CC.TypeOfInputIndex) else CC.TypeOfInputIndex:=-13;
  readln(ccc); if not eof(ccc) then readln(ccc,CC.C_stim);
  readln(ccc); if not eof(ccc) then readln(ccc,PP.tau_m);
  readln(ccc); if not eof(ccc) then readln(ccc,US.t_StartStim_u) else US.t_StartStim_u:=t_StartStim;
  readln(ccc); if not eof(ccc) then readln(ccc,US.t_EndStim_u)   else US.t_EndStim_u  :=t_EndStim;
  readln(ccc); if not eof(ccc) then readln(ccc,US.t_StartStim_s) else US.t_StartStim_s:=t_StartStim;
  readln(ccc); if not eof(ccc) then readln(ccc,US.t_EndStim_s)   else US.t_EndStim_s  :=t_EndStim;
  readln(ccc); if not eof(ccc) then readln(ccc,US.T_pause);
  readln(ccc); if not eof(ccc) then readln(ccc,EC.G1);
  readln(ccc); if not eof(ccc) then readln(ccc,DeviceNumber);
  readln(ccc); if not eof(ccc) then readln(ccc,If_CondCompensation);
  readln(ccc); if not eof(ccc) then readln(ccc,EC.tau_Vfilt);
  readln(ccc); if not eof(ccc) then readln(ccc,EC.tau_Ifilt);
  readln(ccc); if not eof(ccc) then readln(ccc,If_NaAndK);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.gNaP);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.gNa);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.gK);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.g_GJ);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.Vshift);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.TypeOfModNrn);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.TypeOfExpNrn);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.IfTurnOnModelNeuron);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.IfIncludeVrestInVshift);
  readln(ccc); if not eof(ccc) then readln(ccc,NaK.gAHP);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.I_scale);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.Vh_scale);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.Vreal_scale);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.I_offset);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.VL);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.Vh0);
  readln(ccc); if not eof(ccc) then readln(ccc,DynVC.k);
  readln(ccc); if not eof(ccc) then readln(ccc,Vmin);
  readln(ccc); if not eof(ccc) then readln(ccc,Vmax);
  readln(ccc); if not eof(ccc) then readln(ccc,dVmax);
  close(ccc);
end;

end.
