unit RealTime;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart,  DDSpinEdit, Math,
  Init_DC,Acquisition,AcqThread,
  CurrentClamp,DCUnit1,DCUnit2,Passive,Tongue,SMOCs,Na_and_K,Dynamic_VC,
  ThresholdClamp,FiringClamp,Artifacts,OnlineComp,NoiseO;

procedure Read_BG_Parameters;
procedure RealTimeCalculations_at_OneStep;

implementation

procedure Read_BG_Parameters;
begin
  DCForm2.Visible:=true;
  i_end:=1000000;
  IfNoPlotsInBackground:=DCForm1.CheckBox10.Checked;
  if IfNoPlotsInBackground then i_end:=trunc(3600{s}*1000/AcqTime);
  N_steps:=1;
end;

procedure RealTime_BackGround;
begin
  {******}
  Icom:=0;
  {******}
  if ((dt_draw=0)or(time-trunc(time/dt_draw)*dt_draw < AcqTime/2)) and
     (IfNoPlotsInBackground=false) then begin
     { Time }
{     DecodeTime(Now, Hour, Min, Sec, MSec);
     EndTime:=Sec*1000+MSec;
     DCForm1.Label5.Caption:='Time='+IntToStr(EndTime-StartTime);}
     { Drawing }
     if IfInThread=1 then PostMessage(DCForm2.Handle,PROGRESS_POS,0,i)
                     else DCForm2.DrawAtOneStep;
  {*****************************************}
  end;
  if time-trunc(time/T_end)*T_end<AcqTime/2 then begin
     DCForm2.Chart1.BottomAxis.Automatic:=false;
     DCForm2.Chart2.BottomAxis.Automatic:=false;
     DCForm2.Chart1.BottomAxis.Minimum:=max(0,time-Epoch)/1e3;
     DCForm2.Chart2.BottomAxis.Minimum:=max(0,time-Epoch)/1e3;
     DCForm2.Chart1.BottomAxis.Maximum:=(max(0,time-Epoch)+Epoch)/1e3;
     DCForm2.Chart2.BottomAxis.Maximum:=(max(0,time-Epoch)+Epoch)/1e3;
     Application.ProcessMessages;
  end;
end;

procedure RealTimeCalculations_at_OneStep;
begin
  time:=i*AcqTime;
  {*** Protocols ***}
  case Protocol of
  { BackGround }
  0: RealTime_BackGround;
  { Current-Clamp }
  1: RealTime_CurrentClamp;
  { PassiveProperties }
  2: RealTime_Passive;
  { Tongue }
  3: RealTime_Tongue;
  { SMOCs }
  4: RealTime_SMOCs;
  { Dynamic VC }
  5: RealTime_DynVC;
  end;
  {*** SubProtocols ***}
  if If_ThresholdClamp  =1 then RealTime_ThresholdClamp;
  if If_FiringClamp     =1 then RealTime_FiringClamp;
  if If_KillArtifacts   =1 then RealTime_KillArtifacts;
  if If_NaAndK          =1 then RealTime_Na_and_K;
  if If_Noise           =1 then RealTime_Noise;
  { Summarize command signals, Icom and the command signal from Clampex Ireal }
  if   IfAddIrealToIcom=1 then Icom:=Icom + Ireal;
  if i>=i_end then begin Icom:=Icom_offset; {V:=0; Ireal:=0;} end;
  {************************}
  AI0_AI1_AO0(DeviceNumber);//(V,Ireal,Icom);
  {************************}
  {*** Online conductance compensation }
  if If_CondCompensation=1 then RealTime_ElectrodeCompensation;
  {************************}
  if (IfNoPlotsInBackground=false)and(i<=ArrMax) then begin
      Arr_V[i]:=V; Arr_Ireal[i]:=Ireal; Arr_Icom[i]:=Icom; Arr_t[i]:=time;
      if abs(Arr_V[i])    >10{V}*V_scale     then Arr_V[i]:=0;
      if abs(Arr_Ireal[i])>10{V}*Ireal_scale then Arr_Ireal[i]:=0;
  end else begin
//      Arr_V[i]:=Arr_V[i]*0;
  end;
  //if IfInThread<>1 then begin DCForm1.DrawAtOneStep; end;
end;

end.
