unit Compensation;

interface
uses Unit1,Init,Init_DC,Reading;

procedure ElectrodeConductanceCompensation(Smpl :integer);

implementation
uses AnalyzeFC;

procedure ElectrodeConductanceCompensation(Smpl :integer);
var nt_,IfFlaw,d1_,d2_,d3_                                :integer;
    coe,i2,I_,G_,C_,Ireal_,I_filt_,I_Meander_,IM_,Rs_,t   :double;
    Action                                                :string;
begin
  PrepareParameters_FC;
  if Offline.G1=0 then Rs_:=0 else Rs_:=1/Offline.G1;   {GOhm}
  Offline.FC_Vmin:=FC.Vmin;
  IM_:=0;  I_filt_:=0;
      { Voltage correction }
      nt_:=1;
      I_filt_:=0;
      repeat nt_:=nt_+1;
        d1_:=Offline.delay1; if nt_<=d1_ then d1_:=0;  // delay of Ireal
        d2_:=Offline.delay2; if nt_<=d2_ then d2_:=0;  // delay of commands
        d3_:=Offline.delay3; if nt_<=d3_ then d3_:=0;  // delay of EndOfMeander determined by V<Vmin
        { Input I and G }
        Define_I_G(dt*(nt_-d2_)*1000,I_,G_,C_);
        { Action }
        IfFlaw:=0;
        Action:=DefineAction(nt_,d1_,d2_,d3_,IfFlaw);
        if (Action='SwitchToPositivePulse')or
           (Action='SwitchToNegativePulse')or
           (Action='EndOfMeander') then begin
            Offline.Markers[nt_]:=1;
        end else Offline.Markers[nt_]:=0;
        Offline.Act[nt_]:=NumberOfAction(Action);
        Offline.IfFlaw[nt_]:=IfFlaw;
        { Meander }
        I_Meander_Offline(Action,I_Meander_);
        { Delayed and filtered Ireal }
        if Offline.tau_filt>0 then begin
           Ireal_ :=VI[2,nt_-d1_,Smpl];
           I_filt_:=I_filt_ + dt/Offline.tau_filt*(Ireal_-I_filt_);
        end else begin
           I_filt_:=VI[2,nt_-d1_,Smpl];
        end;
        {***********}
        i2:=I_ - G_*(VI[1,nt_,Smpl]-E_inh); // current for compensation
        { What currents to include in compensation? }
        case Form1.ComboBox5.ItemIndex of
        0: begin // Don't use Ireal and FC.Meander
           end;
        1: begin // Use Ireal delayed or filtered
             i2:=I_filt_;
           end;
        2: begin // Use FC.Meander
             IM_:=I_Meander_;
             i2:=i2 + IM_;
           end;
        3,4,5: begin // No conductance compensation
             Rs_:=0;
           end;
        end;
        {***************************************}
        Offline.Vm[nt_]:= VI[1,nt_,Smpl] - Offline.dV_Junction
                        -(i2+Offline.dI_offset)*Rs_;
        Offline.G[nt_] := G_/(1+G_*Rs_);
        Offline.I[nt_] :=  I_+Offline.dI_offset
                        -Offline.G[nt_]*Offline.dV_Junction
                        -(I_+IM_+Offline.dI_offset)*Offline.G[nt_]*Rs_;
        Offline.C[nt_] := C_;
        Offline.Meander[nt_]:=I_Meander_;
        Offline.Ireal[nt_]:=I_filt_;
        {***************************************}
      until nt_>=Nexp[Smpl];
      if (Form1.ComboBox5.ItemIndex in [1,2]) and (Offline.G1>0.01)
      then Offline.FC_Vmin:=FC.Vmin+FC.NegativePulseCurrent/Offline.G1
      else Offline.FC_Vmin:=FC.Vmin;
      {**********}
      { Control signal parameters correction }
      coe:=1+Gclamp_Umea[Smpl]*G_rest{nS}*Rs_{GOhm};
      Iclamp_Umea[Smpl]:=Iclamp_Umea[Smpl]/coe;
      Gclamp_Umea[Smpl]:=Gclamp_Umea[Smpl]/coe;
end;

end.
