unit ExtracelStim;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Series, TeEngine, ExtCtrls, TeeProcs, Chart,
  DDSpinEdit;

procedure ExtractFindAndWriteStimuli;
//procedure TimeFromStimul(var t_Stim :double);
procedure NumberOfStimul(var t :double; var iStim :integer);

var
    NStimuli              :integer;
    StimulTimes           :array[1..200] of double;

implementation

uses Unit1,Unit6,Init,Reading;

var
    Ismoothed,Iextract    :array[0..MaxExp] of double;

procedure SmoothAndSubtract;
var  i          :integer;
begin
  { Smooth }
  Ismoothed[0]          :=VI[2,0,Smpl];
  Ismoothed[Nexp[Smpl]] :=VI[2,Nexp[Smpl],Smpl];
  for i:=1 to Nexp[Smpl]-1 do begin
      Ismoothed[i]:=(VI[2,i-1,Smpl]+VI[2,i,Smpl]+VI[2,i+1,Smpl])/3;
  end;
  { Substract }
  Form6.Series2.Clear;
  for i:=0 to Nexp[Smpl] do begin
      Iextract[i]:=VI[2,i,Smpl]-Ismoothed[i];
      Form6.Series2.AddXY(i*dt*1000,Iextract[i]);
  end;
  Application.ProcessMessages;
end;

procedure FindStimuli;
var i,j,ja,NGoodStim,Nadd,iNext :integer;
    ddI,ddI_limit,StimFreq,dST,x,x_mean,mmm,TimeNext,mem_ddI_limit :double;
begin
  ddI_limit:=Form6.DDSpinEdit1.Value;
  StimFreq :=Form6.DDSpinEdit2.Value;
  mem_ddI_limit:=ddI_limit;
  repeat
    Form6.Series1.Clear;
    NStimuli:=0;
    for i:=1 to Nexp[Smpl]-1 do begin
        ddI:=Iextract[i+1]-2*Iextract[i]+Iextract[i-1];
        if (abs(ddI)>ddI_limit)and(NStimuli<200) then begin
           Form6.Series1.AddXY(i*dt*1000,0);
           NStimuli:=NStimuli+1;
           StimulTimes[NStimuli]:=i*dt*1000;  //ms
        end;
    end;
    Application.ProcessMessages;
    Form6.DDSpinEdit1.Value:=ddI_limit;
    ddI_limit:=ddI_limit/1.2;
  until (ddI_limit<100)or((NStimuli>=Nexp[Smpl]*dt*StimFreq/3)and
                          (StimulTimes[2]<=2*1000/StimFreq));
  { Check quality }
  NGoodStim:=0;
  i:=1;
  repeat i:=i+1;
      dST:=StimulTimes[i]-StimulTimes[i-1];
      { Acquisition error }
      x:=1000/StimFreq-(trunc(dST) mod trunc(1000/StimFreq));
      if (x>=0)and(x<10{ms}*dST/1000*StimFreq) then begin
         NGoodStim:=NGoodStim+1;
         x_mean:=(x_mean*(NGoodStim-1)+x/(dST/1000*StimFreq))/NGoodStim;
      end else begin
         { Exclude the point }
         NStimuli:=NStimuli-1;
         for j:=i to NStimuli do StimulTimes[j]:=StimulTimes[j+1];
         i:=i-1;
      end;
  until i>=NStimuli;
  { Add points }
  i:=1;
  repeat i:=i+1;
      if i<=Nstimuli then dST:=StimulTimes[i]    -StimulTimes[i-1]
                     else dST:=Nexp[Smpl]*dt*1000-StimulTimes[i-1];
      Nadd:=trunc(dST/1000*StimFreq);
      if Nadd>0 then begin
         { Add }
         for ja:=1 to Nadd do begin
             NStimuli:=NStimuli+1;
             for j:=NStimuli downto i+ja do StimulTimes[j]:=StimulTimes[j-1];
             { Find next stimulus time }
//             StimulTimes[i+ja-1]:=StimulTimes[i+ja-2]+1000/StimFreq-x_mean;
             TimeNext:=StimulTimes[i+ja-2]+1000/StimFreq;
             mmm:=0;
             for j:=round((TimeNext-20{ms})/1000/dt) to round(TimeNext/1000/dt) do begin
                 ddI:=Iextract[j+1]-2*Iextract[j]+Iextract[j-1];
                 if abs(ddI)>mmm then begin
                    mmm:=abs(ddI);
                    StimulTimes[i+ja-1]:=j*dt*1000;
                 end;
             end;
         end;
         i:=i+Nadd;
      end;
  until {(i>=Nstimuli)or}(i>=round(Nexp[Smpl]*dt*StimFreq));
  { Draw }
  Form6.Series1.Clear;
  for i:=1 to NStimuli do begin
      Form6.Series1.AddXY(StimulTimes[i],0);
  end;
  Form6.DDSpinEdit1.Value:=mem_ddI_limit;
  Application.ProcessMessages;
end;

procedure ExtractFindAndWriteStimuli;
var i :integer;
begin
  Form6.Visible:=true;
  Form6.Button1.Enabled:=false;
  SmoothAndSubtract;
  if Ismoothed[13]=0 then begin  // if it was not smoothed
     for i:=0 to Nexp[Smpl] do begin
         Iextract[i]:=VI[2,i,Smpl];
     end;
  end;
  {**********}
  FindStimuli;
  {**********}
  WriteStimuli;
  Form6.Button1.Enabled:=true;
end;

{procedure TimeFromStimul(var t_Stim :double);
var i :integer;
begin
  i:=0;
  repeat i:=i+1;
  until (StimulTimes[i]>t_Stim)or(i>=NStimuli);
  i:=i-1;
  if i=0 then t_Stim:=0
         else t_Stim:=t_Stim-StimulTimes[i];
end;}

procedure NumberOfStimul(var t :double; var iStim :integer);
var i :integer;
begin
  { Change 'iStim' if needed }
  if (iStim>NStimuli)or(t>=StimulTimes[iStim+1])or(t<StimulTimes[iStim]) then begin
     if          (iStim>NStimuli) or(t< StimulTimes[1])       then begin
         iStim:=0;
     end else if (iStim<NStimuli)and(t>=StimulTimes[iStim+1]) then begin
         iStim:=iStim+1;
     end else if (iStim>=1)      and(t< StimulTimes[iStim])   then begin
         iStim:=iStim-1;
     end;
  end;
  { Define 't' }
  if (iStim>0)and(t>StimulTimes[iStim]) then t:=t-StimulTimes[iStim]
                                        else t:=0;
end;

end.
