unit Reading;
{ Made from Writing.pas of DC_project.dpr
  in order to read files in Umea's format. }

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart, DDSpinEdit,
  Init_DC,ReadWrite_pars,Init,MathMy;

procedure ReadListOfFiles;
function ReadPastTrace(FName :string) :integer;
procedure FileList_To_ListBox(ListBox_:TListBox);
procedure FileList_From_ListBox(ListBox_:TListBox);
procedure DeleteFileFromFileListOfVizualizator;
procedure Translate_Umea_into_Lyle(Smpl :integer);
procedure Define_I_G(time_:double; var I,G,C:double);
procedure WriteStimuli;
procedure ReadStimuli;

var
    NOfFilesInTheList                     :integer;
    FNames_Umea,FNames_Params_Umea        :array[0..4000] of string;
    Gclamp_Umea,Iclamp_Umea               :array[0..4000] of double;


implementation
uses Unit1,Unit4,ExtracelStim,CurrentClamp,Tongue,Passive;

procedure ReadListOfFiles;
var FName,FName_Params,FNList,d :string;
    ddd :text;
begin
  GetDir(0,d);
  FNList:='ListOfFiles';
  Form4.ListBox1.Clear;
  assign(ddd,FNList); if FileExists(FNList) then reset(ddd) else exit;
  NOfFilesInTheList:=0;
  while not eof(ddd) do begin
     readln(ddd,FName);
     readln(ddd,FName_Params);
     Form4.ListBox1.Items.Add(FName);
     NOfFilesInTheList:=NOfFilesInTheList+1;
  end;
  close(ddd);
  Application.ProcessMessages;
  { Read Past Parameters }
  ReadParametersOf(FName_Params);
end;

function ReadPastTrace(FName :string) :integer;
var
    FName_Params,t1 :string;
    bbb :text;
begin
  ReadPastTrace:=0;
  { Read signals }
  assign(bbb,FName);
  if FileExists(FName) then reset(bbb) else exit;
  i:=-1;
  repeat    i:=i+1;
    read  (bbb,time,V,Icom,Ireal);
    read  (bbb,uu,ss);
    if Protocol=5 then read(bbb,Arr_Vmod[i]);
    if If_KillArtifacts=1 then read(bbb,Arr_Vcorr[i],Arr_G1[i]);
    readln(bbb);
    Arr_V[i]:=V; Arr_Ireal[i]:=Ireal; Arr_Icom[i]:=Icom; Arr_t[i]:=time;
  until eof(bbb);
  i_end:=i;
  close(bbb);
  { Read parameters }
  FName_Params:=FName;
  SetLength(FName_Params,Pos('_trace',FName)-1);
  FName_Params:=FName_Params +'.par';
  ReadParametersOf(FName_Params);
  {***}
  t1:=FName;
  Form1.Label7.Caption:=t1;
  if If_FiringClamp=1 then Form1.Panel1.Caption:='FC'
                      else Form1.Panel1.Caption:='';
  ReadPastTrace:=1;
end;

procedure FileList_To_ListBox(ListBox_:TListBox);
var
    FNList,t1 :string;
    ddd :text;
begin
  { List of files }
  FNList:='ListOfFiles';
  assign(ddd,FNList);
  if FileExists(FNList) then begin
     ListBox_.Clear;
     reset(ddd);
     while not eof(ddd) do begin
        readln(ddd,t1);
        ListBox_.Items.Add(t1);
     end;
     close(ddd);
  end;
  Application.ProcessMessages;
end;

procedure FileList_From_ListBox(ListBox_:TListBox);
var i :integer;
    FName_Params,FName,FNList,t1 :string;
    ddd :text;
begin
  { List of files }
  FNList:='ListOfFiles';
  assign(ddd,FNList);  rewrite(ddd);
  for i:=1 to ListBox_.Items.Count do begin
      writeln(ddd,ListBox_.Items[i-1]);
  end;
  close(ddd);
  Application.ProcessMessages;
end;

procedure DeleteFileFromFileListOfVizualizator;
var j :integer;
    FName_Params,FName :string;
begin
  FileList_To_ListBox(Form1.ListBox2);
  for j:=1 to Form4.ListBox1.Items.Count do begin
      { Find selected files in the whole list and delete them }
      if Form4.ListBox1.Selected[j-1] then begin
         Form1.ListBox2.Selected[2*j-2]:=true;
         Form1.ListBox2.Selected[2*j-1]:=true;
         FName       :=Form1.ListBox2.Items[2*j-2];
         FName_Params:=Form1.ListBox2.Items[2*j-1];
         DeleteFile(FName);
         DeleteFile(FName_Params);
      end;
  end;
  Form4.ListBox1.DeleteSelected;
  Form1.ListBox2.DeleteSelected;
  Application.ProcessMessages;
  FileList_From_ListBox(Form1.ListBox2);
  ReadListOfFiles;
end;

procedure Translate_Umea_into_Lyle(Smpl :integer);
var i,ip,is_step,iu_step  :integer;
    t1_iter               :string;
    uu,ss                 :double;
begin
  Nexp[Smpl]:=i_end;  if Nexp[Smpl]>MaxExp then Nexp[Smpl]:=MaxExp;
  for i:=0 to Nexp[Smpl] do begin
      VI[1,i,Smpl]:=Arr_V[i];
      VI[2,i,Smpl]:=Arr_Ireal[i];
      VI[3,i,Smpl]:=Arr_Icom[i];
  end;
  IfExpIsRead:=1;
  {*********************************************}
  dt:=(Arr_t[1]-Arr_t[0])/1e3;
  { Determine Start and End of stimulation }
  if Pos('.us',FNames_Umea[Smpl])>0 then begin
     tStartClamp:=US.t_StartStim_u;
     tEndClamp  :=min(US.t_EndStim_u,T_end);
  end else begin
     tStartClamp:=t_StartStim;
     tEndClamp  :=min(t_EndStim,T_end);
  end;
  { Define Gclamp & Iclamp }
  t1_iter:='';
  for ip:=Pos('trace',FNames_Umea[Smpl])+5 to Pos('_Err',FNames_Umea[Smpl])-1 do
  t1_iter:=t1_iter+FNames_Umea[Smpl][ip];
  i_step:=StrToInt(t1_iter);
  if Pos('.us',FNames_Umea[Smpl])>0 then begin
     is_step:=trunc((i_step-1)/US.Nu_steps)+1;
     iu_step:=i_step-(is_step-1)*US.Nu_steps;
     if US.Nu_steps<=1 then uu:=US.u_min else
     uu:=US.u_min+(US.u_max-US.u_min)/(US.Nu_steps-1)*(iu_step-1);
     if US.Ns_steps<=1 then ss:=US.s_min else
     ss:=US.s_min+(US.s_max-US.s_min)/(US.Ns_steps-1)*(is_step-1);
     {************************}
     Gclamp_Umea[Smpl]:=ss;
     Iclamp_Umea[Smpl]:=uu;
  end else if Pos('.cc',FNames_Umea[Smpl])>0 then begin
     Gclamp_Umea[Smpl]:=CC.g_stim/PP.G_L;
     Iclamp_Umea[Smpl]:=CC.I_stim/PP.G_L;
  end else begin
     Gclamp_Umea[Smpl]:=0;
     Iclamp_Umea[Smpl]:=0
  end;
  { Vus }
  E_inh:=Vus;
  G_rest:=PP.G_L;
end;

procedure Define_I_G(time_:double; var I,G,C:double);
begin
  case Protocol of
  { BackGround }
  0,5: begin I:=0; G:=0; C:=0; end;
  { Current-Clamp }
  1,4: CC_Define_I_G(time_,I,G,C);
  { PassiveProperties }
  2: PP_Define_I_G(time_,I,G,C);
  { Tongue }
  3: US_Define_I_G(time_,I,G,C);
  end;
end;

{********* Extracellular stimulation *********}

procedure SetFNameStimuli(var FName_Stimuli :string);
begin
  FName_Stimuli:=FNames_Umea[Smpl];
  SetLength(FName_Stimuli,Pos('_trace',FNames_Umea[Smpl])-1);
  FName_Stimuli:=FName_Stimuli+'.stim';
end;

procedure WriteStimuli;
var
    FName_Stimuli :string;
    bbb           :text;
    i             :integer;
begin
  SetFNameStimuli(FName_Stimuli);
  assign(bbb,FName_Stimuli); rewrite(bbb);
  for i:=1 to NStimuli do begin
      writeln(bbb,StimulTimes[i]:9:3);
  end;
  close(bbb);
end;

procedure ReadStimuli;
var
    FName_Stimuli :string;
    bbb           :text;
    i             :integer;
begin
  SetFNameStimuli(FName_Stimuli);
  if FileExists(FName_Stimuli) then begin
     assign(bbb,FName_Stimuli); reset(bbb);
     i:=0;
     repeat i:=i+1;
       readln(bbb,StimulTimes[i]);
     until eof(bbb);
     NStimuli:=i;
     close(bbb);
  end else begin
     {*************************}
     ExtractFindAndWriteStimuli;
     {*************************}
  end;
end;


end.
