unit TreatFile;

interface
uses   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
       StdCtrls, DDSpinEdit,
       Unit1_2,MathMy,Other_Treat;

procedure ReadFiles;
procedure WriteAverageRateAsLyleDoes;
procedure ExcludeWrongPointsIn_ISI_1;
procedure TransferTo2Dmesh;
procedure ExcludeWrongPointsIn_ISI;
procedure AverageSteadyRate;
procedure WriteFile;

const mMax=50; mGMax=150; ColumnMax=200;
var
    NiC,NI,NG                   :integer;
    dI,dG                       :double;
    gClamp,iClamp,G_C,I_C       :array[1..ColumnMax] of double;
    NSp                         :array[1..ColumnMax] of integer;
    ISI,Vav,WAP,Vpeak,VAHP,VT   :array[0..mGMax,0..mMax,0..mMax] of double;
    ISIa,Vava,WAPa,Vpeaka,
    VAHPa,VTa,nuLyle,ISI_last   :array[0..mGMax,0..mMax]         of double;
    iC_iG_iI                    :array[0..mGMax,0..mMax]         of integer;
    NStat                       :array[0..mGMax,0..mMax,0..mMax] of integer;
    NotUsed_iG                  :array[0..mMax]                 of integer;
    ISI_1,tAP,Vav_1,WAP_1,
    Vpeak_1,VT_1,VAHP_1         :array[1..ColumnMax,0..mMax]    of double;

implementation


{*************************************************************************}
procedure ReadFiles;
var
    aaa,aa2,aa3,aa4,aa6,aa7     :text;
    i,iC                :integer;
    t                   :double;
begin
  AssignFile(aaa,'out_nu.dat'); reset(aaa);
  AssignFile(aa2,'out_Vav.dat'); reset(aa2);
  AssignFile(aa3,'out_WidthAP.dat'); reset(aa3);
  AssignFile(aa4,'out_Vpeak.dat'); reset(aa4);
  AssignFile(aa6,'out_VAHP.dat'); reset(aa6);
  AssignFile(aa7,'out_VT.dat'); reset(aa7);
  iC:=0;
  repeat iC:=iC+1;
     read(aaa,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     read(aa2,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     read(aa3,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     read(aa4,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     read(aa6,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     read(aa7,gClamp[iC],iClamp[iC],G_C[iC],I_C[iC],NSp[iC]);
     { if scale is capacitance }
     if Form1.RadioGroup1.ItemIndex=1 then begin
        gClamp[iC]:=G_C[iC];
        iClamp[iC]:=I_C[iC];
     end;
     //i:=0;
     for i:=1 to imin(NSp[iC],mMax) do begin
     //repeat i:=i+1;
        read(aaa,ISI_1[iC,i]);
        read(aa2,Vav_1[iC,i]);
        read(aa3,WAP_1[iC,i]);
        read(aa4,Vpeak_1[iC,i]);
        read(aa6,VAHP_1[iC,i]);
        read(aa7,VT_1[iC,i]);
     //until (eoln(aaa)) or (i=mMax);
     end;
     readln(aaa);
     readln(aa2);
     readln(aa3);
     readln(aa4);
     readln(aa6);
     readln(aa7);
//     NSp:=i; { Number of ISIs recorded }
  until eof(aaa)or(iC=ColumnMax);
  close(aaa);
  close(aa2);
  close(aa3);
  close(aa4);
  close(aa6);
  close(aa7);
  NiC:=iC; { Number of lines in File }
  { Calculate spike times }
  for iC:=1 to NiC do begin
      t:=0;
      for i:=0 to NSp[iC] do begin
          t:=t+LimRev(ISI_1[iC,i],1{Hz});
          tAP[iC,i]:=t;
      end;
  end;
  { Drawing }
  Draw_ISI_1;
end;

{*************************************************************************}
procedure WriteAverageRateAsLyleDoes;
var
    iC,i    :integer;
    bbb     :text;
    nu_Lyle :double;
begin
  AssignFile(bbb,'out2_nuLyle_g_I.dat'); rewrite(bbb);
  for iC:=1 to NiC do begin
      nu_Lyle:=NSp[iC]/0.5{s};
      write  (bbb,gClamp[iC]:9:2,' ',iClamp[iC]:9:2,' ');
      writeln(bbb,nu_Lyle:9:5,' ',ISI_1[iC,imax(0,NSp[iC]-1)]:9:5);
  end;
  close(bbb);
end;

{*************************************************************************}
procedure ExcludeWrongPointsIn_ISI_1;
var
    iC,i :integer;
    I0,Iprev,x :double;
begin
  { Exclude big intervals }
  for iC:=1 to NiC do begin
      for i:=5 to NSp[iC] do begin
          I0   :=LimRev(ISI_1[iC,i],  1{Hz});
          Iprev:=LimRev(ISI_1[iC,i-1],1{Hz});
          if (I0>0)and(Iprev>0)and(I0>1.9*Iprev) then begin
             ISI_1[iC,i]:=0;
          end;
      end;
  end;
  { Exclude first intervals after pauses }
  for iC:=1 to NiC do begin
      for i:=NSp[iC] downto 5 do begin
          I0   :=LimRev(ISI_1[iC,i],  1{Hz});
          Iprev:=LimRev(ISI_1[iC,i-1],1{Hz});
          if (I0>0)and(Iprev=0) then begin
             ISI_1[iC,i]:=0;
          end;
      end;
  end;
  { Drawing }
  Draw_ISI_1;
end;

{*************************************************************************}

procedure Matrix_iC_of_iG_iI;
var iC,iG,iI :integer;
begin
  { Determine NI }
  iC:=1;
  while gClamp[iC]=gClamp[1] do begin
    iC:=iC+1;
  end;
  NI:=iC-2;
  NG:=trunc(NiC/(NI+1));
  for iG:=0 to NG do begin
      for iI:=0 to NI do begin
          iC_iG_iI[iG,iI]:=iG*(NI+1)+iI+1;
      end;
  end;
end;

procedure TransferTo2Dmesh;
var
    iI,iG,i,iC                  :integer;
    maxI,maxG,w,a               :double;
begin
  { Find NI and NG - mesh scales }
{  maxI:=0;
  maxG:=0;
  dG:=200;
  for iC:=1 to NiC do begin
      maxI:=max(maxI,iClamp[iC]);
      maxG:=max(maxG,gClamp[iC]);
      if gClamp[iC]<>0 then dG:=min(dG,gClamp[iC]);
  end;
  dI:=abs(iClamp[2]-iClamp[1]);
  NI:=trunc(maxI/dI); if NiC=1 then NI:=1;
  NG:=trunc(maxG/dG);}
  Matrix_iC_of_iG_iI;
  { Fullfill the table ISI[NI,NG] }
  for iG:=0 to NG do  for iI:=0 to NI do  for i:=0 to mMax do begin
      NStat[iG,iI,i]:=0;
      ISI[iG,iI,i]:=0;
      Vav[iG,iI,i]:=0;
      WAP[iG,iI,i]:=0;
      Vpeak[iG,iI,i]:=0;
      VAHP[iG,iI,i]:=0;
      VT[iG,iI,i]:=0;
  end;
  for iG:=0 to NG do begin
      NotUsed_iG[iG]:=1;
      for iI:=0 to NI do begin
          {for iC:=1 to NiC do begin
              if (iClamp[iC]=dI*iI)and(gClamp[iC]=dG*iG) then begin}
                 iC:=iC_iG_iI[iG,iI];
                 for i:=0 to NSp[iC] do begin
                     a:=LimRev(ISI_1[iC,i],1{Hz});
                     if a>0 then begin
                        NStat[iG,iI,i]:=NStat[iG,iI,i]+1;
                        w:=1/NStat[iG,iI,i];
                        ISI[iG,iI,i]:=ISI[iG,iI,i]*(1-w) + a*w;
                        Vav[iG,iI,i]:=Vav[iG,iI,i]*(1-w) + Vav_1[iC,i]*w;
                        WAP[iG,iI,i]:=WAP[iG,iI,i]*(1-w) + WAP_1[iC,i]*w;
                        Vpeak[iG,iI,i]:=Vpeak[iG,iI,i]*(1-w) + Vpeak_1[iC,i]*w;
                        VAHP[iG,iI,i]:=VAHP[iG,iI,i]*(1-w) + VAHP_1[iC,i]*w;
                        VT[iG,iI,i]:=VT[iG,iI,i]*(1-w) + VT_1[iC,i]*w;
                        NotUsed_iG[iG]:=0;
                     end;
                 end;
              {end;
          end; }
      end;
  end;
  { Drawing }
  DrawTheTable;
end;

{*************************************************************************}
procedure ExcludeWrongPointsIn_ISI;
var
    iI,iG,i :integer;
begin
  { Exclude big intervals }
  for iG:=0 to NG do begin
      for iI:=0 to NI do begin
          for i:=mMax downto 5 do begin
              if ISI[iG,iI,i]>1.9*ISI[iG,iI,i-1] then ISI[iG,iI,i]:=0;
          end;
      end;
  end;
  { Drawing }
  DrawTheTable;
end;

{*************************************************************************}
procedure AverageSteadyRate;
var
    iI,iG,i,iStat,InitialSpikeForAveraging :integer;
begin
  InitialSpikeForAveraging:=trunc(Form1.DDSpinEdit1.Value);  //1
  { Averaging }
  for iG:=0 to NG do begin
      for iI:=0 to NI do begin
          iStat:=0;
          ISIa[iG,iI]:=0; Vava[iG,iI]:=0; WAPa[iG,iI]:=0;
          VAHPa[iG,iI]:=0;  VTa[iG,iI]:=0;
          nuLyle[iG,iI]:=0; ISI_last[iG,iI]:=0;
          for i:=InitialSpikeForAveraging to mMax do begin
              if ISI[iG,iI,i]>0 then begin
                 iStat:=iStat+1;
                 ISIa[iG,iI]:=ISIa[iG,iI]+ISI[iG,iI,i];
                 Vava[iG,iI]:=Vava[iG,iI]+Vav[iG,iI,i];
                 WAPa[iG,iI]:=WAPa[iG,iI]+WAP[iG,iI,i];
                 Vpeaka[iG,iI]:=Vpeaka[iG,iI]+Vpeak[iG,iI,i];
                 VAHPa[iG,iI]:=VAHPa[iG,iI]+VAHP[iG,iI,i];
                 VTa[iG,iI] :=VTa[iG,iI] +VT[iG,iI,i];
              end;
          end;
          if iStat>0 then ISIa[iG,iI]:=ISIa[iG,iI]/iStat;
          if iStat>0 then Vava[iG,iI]:=Vava[iG,iI]/iStat;
          if iStat>0 then WAPa[iG,iI]:=WAPa[iG,iI]/iStat;
          if iStat>0 then Vpeaka[iG,iI]:=Vpeaka[iG,iI]/iStat;
          if iStat>0 then VAHPa[iG,iI] :=VAHPa[iG,iI]/iStat;
          if iStat>0 then VTa[iG,iI]   :=VTa[iG,iI]/iStat;
          if iStat>0 then nuLyle[iG,iI]  :=iStat/0.5{s};
          if iStat>0 then ISI_last[iG,iI]:=ISI[iG,iI,iStat];
      end;
  end;
end;

{*************************************************************************}
procedure WriteFile;
var
    iI,iG,i,NNotUsed    :integer;
    G_,I_               :double;
    vvv,vv2,vv3,vv4,vv6,vv7     :text;
begin
  NNotUsed:=0;  for iG:=0 to NG do  NNotUsed:=NNotUsed+NotUsed_iG[iG];
  assign(vvv,'out2_nu.dat'); rewrite(vvv);
  assign(vv2,'out2_Vav.dat'); rewrite(vv2);
  assign(vv3,'out2_WidthAP.dat'); rewrite(vv3);
  assign(vv4,'out2_Vpeak.dat'); rewrite(vv4);
  assign(vv6,'out2_VAHP.dat'); rewrite(vv6);
  assign(vv7,'out2_VT.dat'); rewrite(vv7);
  writeln(vvv,'ZONE T="out2_nu.dat"');
  writeln(vv2,'ZONE T="out2_Vav.dat"');
  writeln(vv3,'ZONE T="out2_WidthAP.dat"');
  writeln(vv4,'ZONE T="out2_Vpeak.dat"');
  writeln(vv6,'ZONE T="out2_VAHP.dat"');
  writeln(vv7,'ZONE T="out2_VT.dat"');
  writeln(vvv,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  writeln(vv2,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  writeln(vv3,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  writeln(vv4,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  writeln(vv6,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  writeln(vv7,'I= ',NI+1:3,' ,J= ',NG-NNotUsed+1:3,', K=1,F=POINT');
  for iG:=0 to NG do begin
      if NotUsed_iG[iG]=0 then
      for iI:=0 to NI do begin
          G_:=gClamp[iC_iG_iI[iG,iI]];
          I_:=iClamp[iC_iG_iI[iG,iI]];
          write(vvv,G_:9:2,' ',I_:9:2,' ',nuLyle[iG,iI]:6:1,
                                      ' ',LimRev(ISIa[iG,iI],0.001):6:1,
                                      ' ',LimRev(ISI_last[iG,iI],0.001):6:1,' ');
          write(vv2,G_:9:2,' ',I_:9:2,' ',Vava[iG,iI]:6:1,' ');
          write(vv3,G_:9:2,' ',I_:9:2,' ',WAPa[iG,iI]:6:1,' ');
          write(vv4,G_:9:2,' ',I_:9:2,' ',Vpeaka[iG,iI]:6:1,' ');
          write(vv6,G_:9:2,' ',I_:9:2,' ',VAHPa[iG,iI]:6:1,' ');
          write(vv7,G_:9:2,' ',I_:9:2,' ',VTa[iG,iI]:6:1,' ');
          for i:=1 to 13 do begin
              write(vvv,LimRev(ISI[iG,iI,i],0.001):6:1,' ');
              write(vv2,Vav[iG,iI,i]:6:1,' ');
              write(vv3,WAP[iG,iI,i]:6:1,' ');
              write(vv4,Vpeak[iG,iI,i]:6:1,' ');
              write(vv6,VAHP[iG,iI,i]:6:1,' ');
              write(vv7,VT[iG,iI,i]:6:1,' ');
          end;
          writeln(vvv);
          writeln(vv2);
          writeln(vv3);
          writeln(vv4);
          writeln(vv6);
          writeln(vv7);
      end;
  end;
  close(vvv);
  close(vv2);
  close(vv3);
  close(vv4);
  close(vv6);
  close(vv7);
end;

end.
