unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DDSpinEdit,
  Init,MathMy,Init_DC,Unit1,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart;

type
  TForm8 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    DDSpinEdit1: TDDSpinEdit;
    DDSpinEdit2: TDDSpinEdit;
    DDSpinEdit3: TDDSpinEdit;
    DDSpinEdit4: TDDSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Button3: TButton;
    DDSpinEdit5: TDDSpinEdit;
    Label4: TLabel;
    Chart2: TChart;
    LineSeries1: TLineSeries;
    LineSeries2: TLineSeries;
    Button4: TButton;
    Button5: TButton;
    DDSpinEdit6: TDDSpinEdit;
    Label5: TLabel;
    DDSpinEdit7: TDDSpinEdit;
    Label6: TLabel;
    DDSpinEdit8: TDDSpinEdit;
    Label7: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    DDSpinEdit9: TDDSpinEdit;
    Label8: TLabel;
    DDSpinEdit10: TDDSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DDSpinEdit4Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure DDSpinEdit6Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure LineSeries1DblClick(Sender: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure LineSeries2DblClick(Sender: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Series1DblClick(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Series2DblClick(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form8: TForm8;

implementation

{$R *.dfm}

var
    V1,V2,V1f,V2f,GE,GI             :vecExpSmpl;
    N1,N2,nt_shift,skip             :integer;
    Vexc,Vinh,I_repolarizing,VL,GL  :double;

procedure Draw_V1f_V2f;
var i :integer;
begin
  Form8.Series1.Clear;
  Form8.Series2.Clear;
  nt_shift:=trunc(Form8.DDSpinEdit4.Value/1000/dt);
  skip:=trunc(Form1.DDSpinEdit3.Value);
  for i:=imax(0,-nt_shift) to imin(N1,N2-nt_shift) do if (i=0)or(i mod skip=0) then begin
      Form8.Series1.AddXY(i*dt, V1f[i]);
      Form8.Series2.AddXY(i*dt, V2f[i+nt_shift]);
  end;
  Application.ProcessMessages;
end;

procedure Draw_GE_GI;
var i,skip :integer;
begin
  Form8.LineSeries1.Clear;
  Form8.LineSeries2.Clear;
  nt_shift:=trunc(Form8.DDSpinEdit4.Value/1000/dt);
  skip    :=trunc(Form1.DDSpinEdit3.Value);
  for i:=imax(0,-nt_shift) to imin(N1,N2-nt_shift) do if (i=0)or(i mod skip=0) then begin
      Form8.LineSeries1.AddXY(i*dt,GE[i]);
      Form8.LineSeries2.AddXY(i*dt,GI[i]);
  end;
  Form8.Chart2.BottomAxis.Automatic:=false;
  Form8.Chart2.BottomAxis.Maximum:=Form8.Chart1.BottomAxis.Maximum;
  Form8.Chart2.BottomAxis.Minimum:=Form8.Chart1.BottomAxis.Minimum;
  Application.ProcessMessages;
end;

procedure Write_GE_GI;
var i,skip        :integer;
    FName         :string;
    bbb           :text;
begin
  FName:='Lyle_GE_GI.dat';
  assign(bbb,FName); rewrite(bbb);
  nt_shift:=trunc(Form8.DDSpinEdit4.Value/1000/dt);
  skip    :=trunc(Form1.DDSpinEdit3.Value);
  for i:=imax(0,-nt_shift) to imin(N1,N2-nt_shift) do if (i=0)or(i mod skip=0) then begin
      write  (bbb,i*dt:8:3,' ',GE[i]:8:3,' ',GI[i]:8:3);
      writeln(bbb,         ' ',V1[i]:8:3,' ',V2[i]:8:3);
  end;
  close(bbb);
end;

procedure Filter_V1_V2;
var i,N_iter,iter  :integer;
    w              :double;
begin
  for i:=1 to N1 do V1f[i]:=V1[i];
  for i:=1 to N2 do V2f[i]:=V2[i];
  w     :=      Form8.DDSpinEdit6.Value;
  N_iter:=trunc(Form8.DDSpinEdit8.Value);
  V1f[0]:=V1[0];
  V2f[0]:=V2[0];
  for iter:=1 to N_iter do begin
      for i:=1 to N1 do begin
          V1f[i]:=w*V1f[i-1]+(1-w)*V1f[i];
      end;
      for i:=1 to N2 do begin
          V2f[i]:=w*V2f[i-1]+(1-w)*V2f[i];
      end;
  end;
end;

procedure TForm8.Button1Click(Sender: TObject);
{ Mark the current trace as a trace at 0-current }
var i :integer;
begin
  Form8.DDSpinEdit7.Value:=PP.G_L;
  N1:=Nexp[Smpl];
  if N2=0 then N2:=N1;
  for i:=0 to N1 do begin
      V1[i]:=VI[1,i,Smpl];
  end;
  Filter_V1_V2;
  Draw_V1f_V2f;
end;

procedure TForm8.Button2Click(Sender: TObject);
{ Mark the current trace as a trace at the following current (pA): }
var i :integer;
begin
  N2:=Nexp[Smpl];
  for i:=0 to N2 do begin
      V2[i]:=VI[1,i,Smpl];
  end;
  Filter_V1_V2;
  Draw_V1f_V2f;
end;

procedure TForm8.DDSpinEdit4Change(Sender: TObject);
begin
  nt_shift:=trunc(Form8.DDSpinEdit4.Value/1000/dt);
  Draw_V1f_V2f;
end;

procedure SplitConductances;
{ -GE(t)*(V1f(t)-Vexc)-GI(t)*(V1f(t)-Vinh)-GL*(V1f-VL)  =0
  -GE(t)*(V2f(t)-Vexc)-GI(t)*(V2f(t)-Vinh)-GL*(V2f-VL)-I=0
}
var V1_,V2_,d1,d2,Ra,dV :double;
    i                   :integer;
begin
  { Parameters }
  nt_shift:=trunc(Form8.DDSpinEdit4.Value/1000/dt);
  Vexc:=Form8.DDSpinEdit2.Value;
  Vinh:=Form8.DDSpinEdit3.Value;
  I_repolarizing:=Form8.DDSpinEdit1.Value; {pA}
  VL:=Form8.DDSpinEdit5.Value;
  GL:=Form8.DDSpinEdit7.Value;
  Ra:=Form8.DDSpinEdit9.Value; {MOhm}
  dV:=I_repolarizing*Ra/1e3; {mV}
  { Splitting }
  for i:=imax(0,-nt_shift) to imin(N1,N2-nt_shift) do begin
      V1_:=V1f[i];
      V2_:=V2f[i+nt_shift]-dV;  // Compensate series resistance
      d1:=(V1_-Vinh)*(V2_-Vexc)-(V2_-Vinh)*(V1_-Vexc);
      if abs(d1)>1e-8 then
         GI[i]:=-(GL*((V1_-VL)*(V2_-Vexc)-(V2_-VL)*(V1_-Vexc))
                  +I_repolarizing*(V1_-Vexc)) /d1
                      else if i>0 then GI[i]:=GI[i-1] else GI[i]:=0;
      d2:=(V1_-Vexc)*(V2_-Vinh)-(V2_-Vexc)*(V1_-Vinh);
      if abs(d2)>1e-8 then
         GE[i]:=-(GL*((V1_-VL)*(V2_-Vinh)-(V2_-VL)*(V1_-Vinh))
                  +I_repolarizing*(V1_-Vinh)) /d2
                      else if i>0 then GE[i]:=GE[i-1] else GE[i]:=0;
  end;
  { Write and draw }
  Draw_GE_GI;
  Write_GE_GI;
end;

procedure TForm8.Button3Click(Sender: TObject);
begin
  SplitConductances;
end;

procedure TForm8.Button4Click(Sender: TObject);
begin
  Form8.Chart2.CopyToClipboardBitmap;
end;

procedure TForm8.Button5Click(Sender: TObject);
begin
  Form8.Chart1.CopyToClipboardBitmap;
end;

procedure TForm8.DDSpinEdit6Change(Sender: TObject);
begin
  Filter_V1_V2;
  Draw_V1f_V2f;
end;

procedure TForm8.Button6Click(Sender: TObject);
{ Set constant voltage trace as V(t)=VE. }
var i :integer;
begin
  { Propose current value as I=(V-VL)*GL }
{  Form8.DDSpinEdit1.Value:=(Form8.DDSpinEdit10.Value-Form8.DDSpinEdit5.Value)*
                            Form8.DDSpinEdit7.Value;}
  N2:=N1;
  for i:=0 to N2 do begin
      V2[i]:=Form8.DDSpinEdit10.Value;
  end;
  Filter_V1_V2;
  Draw_V1f_V2f;
end;

procedure TForm8.Button7Click(Sender: TObject);
begin
  Form8.Chart1.Legend.Visible:=not(Form8.Chart1.Legend.Visible);
  Form8.Chart2.Legend.Visible:=not(Form8.Chart2.Legend.Visible);
end;

procedure TForm8.LineSeries1DblClick(Sender: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  Form8.LineSeries1.Active:=false;
end;

procedure TForm8.LineSeries2DblClick(Sender: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  Form8.LineSeries2.Active:=false;
end;

procedure TForm8.Series1DblClick(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Form8.Series1.Active:=false;
end;

procedure TForm8.Series2DblClick(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Form8.Series2.Active:=false;
end;

procedure TForm8.Button8Click(Sender: TObject);
begin
  Form8.LineSeries1.Active:=true;
  Form8.LineSeries2.Active:=true;
  Form8.Series1.Active:=true;
  Form8.Series2.Active:=true;
end;

end.
