unit main;

interface
uses   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
       StdCtrls, DDSpinEdit,
       Unit1,Unit2,Unit4,Unit5,
       Init,MathMy,Statistics,Analyzer,Reading,CurrentClamp,
       ExtracelStim,Init_DC,Compensation;

procedure PrintTime(t :double);
function Parameters :boolean;
procedure ReadExpData(Smpl :integer);
procedure Lissajous;
procedure Draw_dIdV;
procedure DrawArray(VorI, Smpl :integer);
procedure Draw2Arrays(Smpl :integer);
procedure ReadAndDraw;
procedure RunStatistics;
procedure OpenOutFiles;
procedure F_I_curves;
procedure TreatAllDirs;
function ReadAndTreatSelectedFiles :boolean;


implementation

procedure PrintTime(t :double);
var t1 :string;
begin
   str(t:9:3,t1);
   t1:='t='+t1;
   Form1.Canvas.TextOut(20,2,t1);
end;

function Parameters_OldLyleFormat :boolean;
begin
  Form4.Visible:=false;
  NSmpl:=25;
  { Tries to set filenames, if not set }
  if FNameDialog1='' then  if AskFileName=false then
  begin Parameters_OldLyleFormat:=false; exit; end;
  FName[1] :=FNameDialog1;
  FName[2] :=FNameDialog2;
  { Reads }
  if FNameDialog3<>'' then begin
     assign(aaa,FNameDialog3); reset(aaa);
     readln(aaa);
     readln(aaa);
     readln(aaa,gstart);
     gClamped:=gstart;
     Form1.DDSpinEdit7.Value:=gClamped;
     readln(aaa,gincrement);
     readln(aaa,tStartClamp);
     readln(aaa,gpulsewidth);
     readln(aaa);
     readln(aaa,SampleRate);
     readln(aaa,istart);
     readln(aaa,iincrement);
     readln(aaa,idelay);
     readln(aaa);
     readln(aaa,Bridge);
     Form1.DDSpinEdit4.Value:=Bridge;
     close(aaa);
  end else gClamped:=15 {nS};
  tEndClamp:=tStartClamp+gpulsewidth;
  Parameters_OldLyleFormat:=true;
end;

function Parameters_NF :boolean;
var i                                                        :integer;
    Erev,IPulseWidth,tmp  :double;
begin
  Form4.Visible:=false;
  if FNameDialog1='' then  AskFileName;
  FName[1] :=FNameDialog1;
  FName[2] :=FNameDialog2;
  if FNameDialog3<>'' then begin
     { Define file format }
     if      AnsiPos('.gs1',FNameDialog3)>0 then  ivb_gst_gs1:='gs1'
     else if AnsiPos('.gst',FNameDialog3)>0 then  ivb_gst_gs1:='gst'
     else if AnsiPos('.ivb',FNameDialog3)>0 then  ivb_gst_gs1:='ivb'
     else                                         ivb_gst_gs1:='';
     assign(aaa,FNameDialog3); reset(aaa);
     readln(aaa);
     read(aaa,Iterations);
     read(aaa,gstart,gincrement,tStartClamp);
     read(aaa,gpulsewidth,Erev);
     read(aaa,SampleRate,istart,iincrement,idelay,IPulseWidth,Bridge);
     read(aaa,CapCompensation,Nothing,
          SweepDuration,CycleTime,dtExp,G_rest,E_inh,G_inh,E_ex,G_ex);
     NSmpl:=Iterations;
     gClamped:=gstart + G_inh*G_rest;
     Form1.DDSpinEdit7.Value:=gClamped;
     Form1.DDSpinEdit4.Value:=Bridge;
     close(aaa);
     { Read sequence of GE-steps }
     if ivb_gst_gs1='gs1' then begin
        assign(aaa,FNameDialog4); reset(aaa);
        for i:=1 to NSmpl do begin
            readln(aaa,tmp,GE_array[i]);
        end;
        close(aaa);
     end else  for i:=1 to NSmpl do GE_array[i]:=0;
  end else gClamped:=15 {nS};
  if ivb_gst_gs1='ivb' then tEndClamp:=idelay     +IPulseWidth else
                            tEndClamp:=tStartClamp+gpulsewidth;
  Parameters_NF:=true;
end;

function Parameters_UmeaFormat :boolean;
begin
  Form4.Visible:=true;
  Parameters_UmeaFormat:=true;
end;

procedure CommonParameters;
begin
  n_Draw:=trunc(Form1.DDSpinEdit1.Value);
  SpikeCriteria.V_min     :=Form1.DDSpinEdit14.Value;
  SpikeCriteria.dVdt_min  :=Form1.DDSpinEdit11.Value;
  SpikeCriteria.d2Vdt2_min:=Form1.DDSpinEdit12.Value;
  SpikeCriteria.TimeWindow:=Form1.DDSpinEdit15.Value/1e3;
  AHPfast.dVdt_min        :=Form1.DDSpinEdit16.Value;
  AHPfast.TimeSincePeak   :=Form1.DDSpinEdit17.Value/1e3;
end;

function Parameters :boolean;
begin
  CommonParameters;
  case Form1.ComboBox2.ItemIndex of
  0: {Old Lyle's format} Parameters:=Parameters_OldLyleFormat;
  1: {New Lyle's format} Parameters:=Parameters_NF;
  2: {Umea's format}     Parameters:=Parameters_UmeaFormat;
  end;
end;
{******************************************************************************}

procedure ReadExpData_NF(VorI, Smpl :integer);
var
    i,j,skip,ie         :integer;
    value,dum           :double;
    Varr                :array[1..50] of double;
    t1,name             :string;
begin
  skip:=trunc(Form1.DDSpinEdit3.Value);
  if Smpl<10 then str(Smpl:1,t1) else str(Smpl:2,t1);
  name:=FName[VorI];
  ie:=Length(name);
  name[ie-16]:=t1[1];
  assign(aaa,name); reset(aaa);
  i:=-1; j:=-1;
  while not (eof(aaa)or(i>MaxExp)) do begin
    i:=i+1;
    readln(aaa,dum,Varr[1]);
    t:=i/SampleRate{Hz};
    if trunc(i/skip)*skip=i then begin  {Memorize with skip}
       j:=j+1;
       VI[VorI,j,Smpl]:=Varr[1];
       if j=1 then dt:=t;
    end;
  end;
  Nexp[Smpl]:=j;
  close(aaa);
  IfExpIsRead:=1;
  t1:=FName[VorI];  //Delete(t1,Pos(RootDir,t1),Length(RootDir));
  Form1.Label7.Caption:=t1;
end;

procedure ReadExpData_Lyle(VorI, Smpl :integer);
var
    i,j,skip,icol       :integer;
    value,dum           :double;
    Varr                :array[1..50] of double;
    t1                  :string;
begin
//  if Form1.ComboBox2.ItemIndex=1 then begin ReadExpData_NF(VorI,Smpl); exit; end;
  skip:=trunc(Form1.DDSpinEdit3.Value);
  assign(aaa,FName[VorI]); reset(aaa);
  i:=-1; j:=-1;
  while not (eof(aaa)or(i>MaxExp)) do begin
    i:=i+1;
    icol:=0;
    repeat icol:=icol+1;
//           if Form1.ComboBox2.ItemIndex=1 then read(aaa,dum);
           read(aaa,Varr[icol]);
    until eoln(aaa);
    readln(aaa);
    t:=i/SampleRate{Hz};
    if trunc(i/skip)*skip=i then begin  {Memorize with skip}
       j:=j+1;
       VI[VorI,j,Smpl]:=Varr[Smpl];
       if j=1 then dt:=t;
    end;
  end;
  Nexp[Smpl]:=j;
  NSmpl:=icol;
  close(aaa);
  IfExpIsRead:=1;
  t1:=FName[VorI];  //Delete(t1,Pos(RootDir,t1),Length(RootDir));
  Form1.Label7.Caption:=t1;
end;

procedure ReadExpData_Umea(Smpl :integer);
var
    t1                  :string;
begin
  if FNames_Umea[Smpl]='' then exit;
  ReadPastTrace(FNames_Umea[Smpl]);
  Translate_Umea_into_Lyle(Smpl);
  {***}
  t1:=FNames_Umea[Smpl];
  Form1.Label7.Caption:=t1;
end;

procedure Filter(VorI,Smpl :integer);
var nt_,iter :integer;
    tauF :double;
//    x_                :array[0..MaxExp] of double;
begin
  tauF:=Form1.DDSpinEdit18.Value/1e3;
  FOR iter:=1 to trunc(Form1.DDSpinEdit19.Value) DO BEGIN
      { Forward }
      nt_:=0;
      repeat nt_:=nt_+1;
        VI[VorI,nt_,Smpl] := VI[VorI,nt_-1,Smpl]
                           + dt/tauF*(- VI[VorI,nt_-1,Smpl] + VI[VorI,nt_,Smpl]);
      until nt_>=Nexp[Smpl];
      { Backward }
      nt_:=Nexp[Smpl];
      repeat nt_:=nt_-1;
        VI[VorI,nt_,Smpl] := VI[VorI,nt_+1,Smpl]
                           + dt/tauF*(- VI[VorI,nt_+1,Smpl] + VI[VorI,nt_,Smpl]);
      until nt_=0;
      {**********}
  END;
end;

procedure ReadExpData(Smpl :integer);
begin
  case Form1.ComboBox2.ItemIndex of
  0,1: {Old and New Lyle's formats} begin
                                      ReadExpData_Lyle(1, Smpl);
                                      ReadExpData_Lyle(2, Smpl);
                                    end;
  2:   {Umea's format}              ReadExpData_Umea(Smpl);
  end;
  { Filter }
  if Form1.CheckBox17.Checked then begin
     Filter(1,Smpl);
  end;
  { Compensation }
  Offline.G1       :=Form1.DDSpinEdit21.Value{nS};      // electrode conductance
  Offline.C1_C     :=Form1.DDSpinEdit37.Value;          // amplifier capacitance
  Offline.tau_filt :=Form1.DDSpinEdit28.Value{mus}/1e6; // Ireal filter time constant
  Offline.delay1   :=trunc(Form1.DDSpinEdit29.Value);   // delay of V relative to real current in steps
  Offline.delay2   :=trunc(Form1.DDSpinEdit34.Value);   // delay in steps
  Offline.delay3   :=trunc(Form1.DDSpinEdit35.Value);   // delay in steps
  Offline.dV_Junction:=Form5.DDSpinEdit1.Value{+V_offset}; {mV}   // Junction potential  // commented on 10.09.2012
  Offline.dI_offset  :=Form5.DDSpinEdit5.Value; {pA}   // Offset current - additional polarization
  Offline.dG_offset  :=Form5.DDSpinEdit4.Value; {nS}   // Offset cond.   - applied after estimation, before correction I,G into GE,GI. 
  Offline.w_Filter_z1_z2:=Form5.DDSpinEdit6.Value;     // weight to filter z1,z2 
  if If_FiringClamp=1 then ElectrodeConductanceCompensation(Smpl);
end;
{******************************************************************************}

procedure Calculate_Gclamp_Iclamp_Lyle(Smpl :integer; var Gclamp,Iclamp :double);
var g_ :double;
begin
  if GE_array[Smpl]<>0 then  g_:=GE_array[Smpl] else g_:=G_ex*Smpl;
  Gclamp:=gstart+gincrement*(Smpl-1) + (G_inh+g_)*G_rest;
  if G_rest<>0 then
     Iclamp:=(istart+iincrement*(Smpl-1) + g_*(E_ex-E_inh)*G_rest)/G_rest
               else
     Iclamp:=(istart+iincrement*(Smpl-1) + g_*(E_ex-E_inh));
end;

procedure Calculate_Gclamp_Iclamp_Umea(Smpl :integer; var Gclamp,Iclamp :double);
begin
  Gclamp:=Gclamp_Umea[Smpl];
  Iclamp:=Iclamp_Umea[Smpl];
end;

procedure Calculate_Gclamp_Iclamp(Smpl :integer; var Gclamp,Iclamp :double);
begin
  case Form1.ComboBox2.ItemIndex of
  0,1: {Lyle's formats} Calculate_Gclamp_Iclamp_Lyle(Smpl, Gclamp,Iclamp);
  2:   {Umea's format}  Calculate_Gclamp_Iclamp_Umea(Smpl, Gclamp,Iclamp);
  end;
end;

procedure Lissajous;
var
   i,Smpl             :integer;
   dVdt,tStart_,tEnd_ :double;
begin
  Smpl:=trunc(Form1.DDSpinEdit2.Value);
  tStart_:=Form1.DDSpinEdit26.Value; {ms}
  tEnd_  :=Form1.DDSpinEdit27.Value; {ms}
  { I-V }
  Form1.Series10.Clear;
  Form1.Series22.Clear;
  Form1.Series23.Clear;
  Form1.Series24.Clear;
  for i:=0 to Nexp[Smpl] do begin
      if (dt*i*1000>tStart_) and (dt*i*1000<tEnd_) then begin
         Form1.Series10.AddXY(VI[1,i,Smpl],VI[2,i,Smpl]);
         Form1.Series22.AddXY(VI[1,i,Smpl], Offline.Ireal[i]);
         Form1.Series23.AddXY(Offline.Vm[i],Offline.Ireal[i]-Offline.Meander[i]);
         Form1.Series24.AddXY(Offline.Vm[i],Offline.Ireal[i]);
      end;
  end;
  Application.ProcessMessages;
  { dVdt-V }
  Form1.Series11.Clear;
  for i:=0 to Nexp[Smpl] do begin
      if (dt*i*1000>tStart_) and (dt*i*1000<tEnd_) then begin
         dVdt:=(VI[1,i,Smpl]-VI[1,i-1,Smpl])/(dt*i*1000);
         Form1.Series11.AddXY(VI[1,i,Smpl],dVdt);
      end;
  end;
  Application.ProcessMessages;
end;

procedure Draw_dIdV;
var
   i,Smpl                                   :integer;
   dIdV,tStart_,tEnd_,dV_,dIdV_av,tau_filt_ :double;
begin
  Form1.Chart6.Visible:=true;
  Smpl:=trunc(Form1.DDSpinEdit2.Value);
  tStart_:=Form1.DDSpinEdit26.Value; {ms}
  tEnd_  :=Form1.DDSpinEdit27.Value; {ms}
  tau_filt_:=Form1.DDSpinEdit36.Value; {ms}
  { dI/dVm }
  Form1.Series25.Clear;
  Form1.Series26.Clear;
  dIdV_av:=0;
  for i:=1 to Nexp[Smpl] do begin
      if (dt*i*1000>tStart_) and (dt*i*1000<tEnd_) then begin
         dV_:=Offline.Vm[i]-Offline.Vm[i-1];
         if dV_>0.01{mV} then begin
            dIdV:=(Offline.Ireal[i]{-Offline.Meander[i]}-
                   Offline.Ireal[i-1]{+Offline.Meander[i-1]})/dV_;
            { Filter }
            if tau_filt_=0 then dIdV_av:=dIdV else
            dIdV_av:=dIdV_av + dt*1000/tau_filt_*(dIdV-dIdV_av);
            Form1.Series25.AddXY(dt*i*1000,dIdV_av);
            if Offline.Act[i]=3 {'PositivePulse'} then
            Form1.Series26.AddXY(dt*i*1000,dIdV);
         end;
      end;
  end;
  Application.ProcessMessages;
end;

procedure DrawArray(VorI, Smpl :integer);
var i,iStim,skip     :integer;
    Gclamp,Iclamp,t_ :double;
    t1               :string;
begin
  skip:=trunc(Form1.DDSpinEdit3.Value);
  Form1.Series1.Clear;
//  Form1.Series1.Title:=FName[VorI];
  for i:=0 to Nexp[Smpl] do if (i=0)or(i mod skip=0) then begin
      t_:=dt*i*1000;
      { Align to stimuli }
      if Form1.CheckBox15.Checked then NumberOfStimul(t_,iStim);
      Form1.Series1.AddXY(t_,VI[VorI,i,Smpl]);
  end;
  Calculate_Gclamp_Iclamp(Smpl,Gclamp,Iclamp);
  Form1.DDSpinEdit7.Value:=Gclamp;
  Form1.DDSpinEdit8.Value:=Iclamp;
  str(Smpl:3,t1);
  Form1.Label4.Visible:=true;
  Form1.Label4.Caption:='File number='+t1;
  Application.ProcessMessages;
end;

procedure Draw2Arrays(Smpl :integer);
var i,iStim,skip              :integer;
    Gclamp,Iclamp,I_,G_,C_,t_ :double;
begin
  skip:=trunc(Form1.DDSpinEdit3.Value);
  Form1.Series1.Clear;
  Form1.Series2.Clear;
  Form1.Series31.Clear;
//  Form1.Series1.Title:=FName[1];
//  Form1.Series2.Title:=FName[2];
  Form1.Series18.Clear;
  Form1.Series19.Clear;
  for i:=0 to Nexp[Smpl] do if ((i=0)or(i mod skip=0))and(i<nDrawMax*skip) then begin
      t_:=dt*i*1000;
      { Align to stimuli }
      if Form1.CheckBox15.Checked then NumberOfStimul(t_,iStim);
      Form1.Series1.AddXY(t_,VI[1,i,Smpl]);
      Form1.Series2.AddXY(t_,VI[2,i,Smpl]);
      Form1.Series31.AddXY(t_,VI[3,i,Smpl]);
      if (Form1.CheckBox13.Checked)and(i mod 10=0) then begin
         Define_I_G(dt*i*1000,I_,G_,C_);
         Form1.Series18.AddXY(t_,I_);
         Form1.Series19.AddXY(t_,G_);
      end;
  end;
  Calculate_Gclamp_Iclamp(Smpl,Gclamp,Iclamp);
  Form1.DDSpinEdit7.Value:=Gclamp;
  Form1.DDSpinEdit8.Value:=Iclamp;
  Application.ProcessMessages;
end;

procedure ReadAndDraw;
begin
  if not(Parameters) then exit;
  Smpl:=trunc(Form1.DDSpinEdit2.Value);
  Smpl:=imin(Smpl,NSmpl); Smpl:=imax(Smpl,1);
  {****************}
  ReadExpData(Smpl);
  {****************}
  Form1.Label19.Caption:='Read extracellular stimuli';
  if (Form1.CheckBox14.Checked)or(Form1.CheckBox15.Checked) then ReadStimuli;
//  DrawArray(1,1);
  Draw2Arrays(Smpl);
  FindAllSpikes(Smpl);
  if Form1.PageControl1.ActivePageIndex=2 then Lissajous;
end;

procedure RunStatistics;
var i,ib,ie :integer;
begin
  Form1.Series4.Clear;
  Form1.Series5.Clear;
  Form1.Series4.AddXY(0,0);
  Form1.Series5.AddXY(0,0);
  ib:=trunc(tStartClamp/dt)+1;
  ie:=imin(trunc(tEndClamp/dt),Nexp[Smpl]);
  for i:=ib to ie do begin
      nt:=i-ib;
      PrintTime(nt*dt);
      AnalyseStatistics(VI[1,i,Smpl]);
      if (i mod trunc(Form1.DDSpinEdit6.Value))=0 then begin
         Form1.Series4.Delete(Form1.Series4.Count-1);
         Form1.Series5.Delete(Form1.Series5.Count-1);
         Form1.Series4.AddXY(dt*i*1000,VI[2,i,Smpl]);
         Form1.Series5.AddXY(dt*i*1000,VI[1,i,Smpl]);
      end;
  end;
end;

function LimRev(x,limit :double):double;
begin
  if x<limit then LimRev:=0
             else LimRev:=1/x;
end;

procedure OpenOutFiles;
begin
//  RootDir:='E:\Anton\Experiments\Data\2005.09.14\';
//  RootDir:='E:\Anton\Experiments\Data\2005.10.13\';
//  RootDir:=Form1.ComboBox1.Items[Form1.ComboBox1.ItemIndex];
  GetDir(0,RootDir);
  RootDir:=RootDir+'\';
  assign(vvv,RootDir+'out_nu.dat');          rewrite(vvv);  close(vvv);
  assign(vv2,RootDir+'out_Vav.dat');         rewrite(vv2);  close(vv2);
  assign(vv3,RootDir+'out_WidthAP.dat');     rewrite(vv3);  close(vv3);
  assign(vv4,RootDir+'out_Vpeak.dat');       rewrite(vv4);  close(vv4);
  assign(vv5,RootDir+'out_g_I_i_all.dat');   rewrite(vv5);  close(vv5);
  assign(vv6,RootDir+'out_VAHP.dat');        rewrite(vv6);  close(vv6);
  assign(vv7,RootDir+'out_VT.dat');          rewrite(vv7);  close(vv7);
  assign(vv8,RootDir+'out_AdaptRatio.dat');  rewrite(vv8);  close(vv8);
  assign(vv9,RootDir+'out_Rate.dat');        rewrite(vv9);  close(vv9);
  assign(vv10,RootDir+'out_VAHPfast.dat');   rewrite(vv10); close(vv10);
  assign(vv11,RootDir+'out_all_Rheobase.dat');   rewrite(vv11);  close(vv11);
end;

procedure F_I_curves;
var Smpl,i,MaxW,IIspike_good,IIspike23,IIspike13  :integer;
    Gclamp,Iclamp,nu,G_C,I_C,nu_Last              :double;
begin
  Form2.Visible:=true;
  if (not(Parameters))or(NSmpl=0) then exit;
  { Condition on Bridge }
  if Bridge<Form1.DDSpinEdit5.Value then exit;
  Smpl:=0;
  repeat Smpl:=Smpl+1;
    Form1.DDSpinEdit2.Value:=Smpl;
    ReadExpData(Smpl);
    Draw2Arrays(Smpl);
    {******************}
    FindAllSpikes(Smpl);
    {******************}
    { Cut spike train if the analysis interval limit is over }
    if Form1.DDSpinEdit41.Value<tEndClamp-tStartClamp then begin
       i:=1;
       repeat i:=i+1;
         if tAPs[i]*1000>Form1.DDSpinEdit41.Value then IIspike:=i-1;
       until i>=IIspike;
       tEndClamp:=tStartClamp+Form1.DDSpinEdit41.Value;
    end;
    { Cut spike train if ISI changes in 1.9 times }
    IIspike_good:=IIspike;
    if Form1.CheckBox18.Checked then begin
       i:=3;      { start from the forth ISI }
       repeat i:=i+1;
         if ISI[i]>Form1.DDSpinEdit22.Value*ISI[i-1] then IIspike_good:=i-1;
       until i>=IIspike_good;
    end;
    { Define nu_Last }
    if (IIspike_good>trunc(Form1.DDSpinEdit40.Value))and
       (tAPs[IIspike_good]>tStartClamp/1000) then
         nu_Last:=IIspike/(tAPs[IIspike_good]-tStartClamp/1000)
    else nu_Last:=0;
    { Mean for last 1/3 of t_end }
    if Form1.CheckBox24.Checked then begin
       IIspike23:=IIspike;
       if IIspike>=2 then begin
          i:=1;
          repeat i:=i+1;
            if tAPs[i]*1000-tStartClamp<2/3*(tEndClamp-tStartClamp) then begin
                IIspike23:=i;
            end;
          until i>=IIspike;
       end;
       nu_Last:=(IISpike-IIspike23)/(tEndClamp-tStartClamp)*1000*3;
    end;
    { Mean for last 2/3 of t_end }
    if Form1.CheckBox25.Checked then begin
       IIspike13:=IIspike;
       if IIspike>=2 then begin
          i:=1;
          repeat i:=i+1;
            if tAPs[i]*1000-tStartClamp<1/3*(tEndClamp-tStartClamp) then begin
                IIspike13:=i;
            end;
          until i>=IIspike;
       end;
       nu_Last:=(IISpike-IIspike13)/(tEndClamp-tStartClamp)*1000*3/2;
    end;
    { Drawing ***********************************************************}
    Gclamp:=Form1.DDSpinEdit7.Value;
    Iclamp:=Form1.DDSpinEdit8.Value;
    if PP.tau_m>0 then G_C:=Gclamp/PP.tau_m else G_C:=0;
    if PP.tau_m>0 then I_C:=Iclamp/PP.tau_m else I_C:=0;
    if IIspike>0 then begin
       if ISI[1]>0 then Form2.Series1.AddXY(Iclamp,LimRev(ISI[1],0.001));
       if ISI[2]>0 then Form2.Series2.AddXY(Iclamp,LimRev(ISI[2],0.001));
       if ISI[3]>0 then Form2.Series3.AddXY(Iclamp,LimRev(ISI[3],0.001));
       if ISI[4]>0 then Form2.Series4.AddXY(Iclamp,LimRev(ISI[4],0.001));
       if ISI[5]>0 then Form2.Series5.AddXY(Iclamp,LimRev(ISI[5],0.001));
       if ISI[6]>0 then Form2.Series6.AddXY(Iclamp,LimRev(ISI[6],0.001));
                        Form2.Series7.AddXY(Iclamp,IIspike);
                        Form2.Series8.AddXY(Iclamp,nu_Last);
                        Form2.LineSeries7.AddXY(Gclamp,IIspike);
                        Form2.LineSeries8.AddXY(Gclamp,nu_Last);
       Application.ProcessMessages;
    end;
    { Writing ***********************************************************}
    MaxW:=IIspike;//20;    //Set to fixed number if standart is needed for plotting
    { Writing ISI - 'out_nu.dat'}
    append(vvv);
    write(vvv,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vvv,LimRev(ISI[i],0.001):6:1,' ');
    writeln(vvv);
    close(vvv);
    { Writing Vav }
    append(vv2);
    write(vv2,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv2,Vav[i]:6:1,' ');
    writeln(vv2);
    close(vv2);
    { Writing WidthAP }
    append(vv3);
    write(vv3,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv3,WidthAP[i]:6:3,' ');
    writeln(vv3);
    close(vv3);
    { Writing Vpeak }
    append(vv4);
    write(vv4,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv4,Vpeak[i]:6:3,' ');
    writeln(vv4);
    close(vv4);
    { Writing 'out_g_I_i_all.dat' }
    append(vv5);
    for i:=1 to IIspike do begin
        nu:=LimRev(tAPs[i]-tAPs[i-1],0.001);
//        if i=1 then nu:=LimRev(tAPs[i]-tAPs[i-1],0.001);
        {         1              2              3           4           5  }
        write(vv5,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',i:3,' ');
        {         6          7             7                               }
        write(vv5,nu:6:1,' ',VT[i]:6:3,' ',Vpeak[i]-VT[i]:6:3,' ');
        {         9                     10                                 }
        write(vv5,VT[i]-VAHP[i]:6:3,' ',WidthAP[i]:6:3,' ');
        {           11               12                 13                 }
        writeln(vv5,VAHP[i]:6:3,' ',VAHPfast[i]:6:3,' ',tAPs[i]*1000:7:2);
    end;
    close(vv5);
    { Writing VAHP }
    append(vv6);
    write(vv6,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv6,VAHP[i]:6:3,' ');
    writeln(vv6);
    close(vv6);
    { Writing VT }
    append(vv7);
    write(vv7,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv7,VT[i]:6:3,' ');
    writeln(vv7);
    close(vv7);
    { Writing AdaptRatio }
    append(vv8);
    write(vv8,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    if ISI[2]>0 then write(vv8,ISI[IIspike]/ISI[2]:6:3,' ');
    writeln(vv8);
    close(vv8);
    { Writing Rate }
    append(vv9);
    write(vv9,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    if tEndClamp-tStartClamp>0 then write(vv9,IIspike/(tEndClamp-tStartClamp)*1000:9:1,' ') else write(vv9,' 0 ');
    writeln(vv9,nu_Last:9:1);
    close(vv9);
    { Writing VAHP }
    append(vv10);
    write(vv10,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ',IIspike:3,' ');
    for i:=1 to imin(MaxW,mMaxAP) do  write(vv10,VAHPfast[i]:6:3,' ');
    writeln(vv10);
    close(vv10);
    { Rheobase }
    if IIspike=1 then begin
        i:=1;
        append(vv11);
        {          1              2              3           4           5  }
        write(vv11,Gclamp:7:2,' ',Iclamp:7:2,' ',G_C:7:4,' ',I_C:7:4,' ','0',' ');
        {          6          7             7                               }
        write(vv11,nu:6:1,' ',VT[i]:6:3,' ',Vpeak[i]-VT[i]:6:3,' ');
        {          9                     10                                 }
        write(vv11,VT[i]-VAHP[i]:6:3,' ',WidthAP[i]:6:3,' ');
        {            11               12                 13                 }
        writeln(vv11,VAHP[i]:6:3,' ',VAHPfast[i]:6:3,' ',tAPs[i]*1000:7:2);
        close(vv11);
    end;
  until Smpl=NSmpl;
end;

procedure TreatAllDirs;
var
    gSmpl,IfFound,i,gst_or_gs1      :integer;
    t1                              :string;
    sr                              :TSearchRec;
begin
  OpenOutFiles;
  { Read Root-Directory content }
  IfFound:=FindFirst(RootDir+'*.*',faDirectory, sr);
  NgSmpl:=0;
  while FindNext(sr)=0 do begin
    if Pos('_gst', sr.Name)>0 then begin
       Delete(sr.Name,Length(sr.Name)-3,4);
       NgSmpl:=NgSmpl+1;
       DirName[NgSmpl]:=sr.Name;
       gst_or_gs1:=1;
    end;
    if Pos('gs1', sr.Name)>0 then begin
       //Delete(sr.Name,Length(sr.Name)-3,4);
       NgSmpl:=NgSmpl+1;
       DirName[NgSmpl]:=sr.Name;
       gst_or_gs1:=2;
    end;
  end;
  FindClose(sr);
{  NgSmpl:=12;
  DirName[1] :='14180035';
  DirName[2] :='14180207';
  DirName[3] :='14180247';
  DirName[4] :='14180323';
  DirName[5] :='14180404';
  DirName[6] :='14180437';
  DirName[7] :='14180914';
  DirName[8] :='14181029';
  DirName[9] :='14181225';
  DirName[10]:='14181324';
  DirName[11]:='14181416';
  DirName[12]:='14181501';
  if RootDir='E:\Anton\Experiments\nu(u_s)\2005.10.13\' then begin
  NgSmpl:=18;
  DirName[1] :='13173020';
  DirName[2] :='13173112';
  DirName[3] :='13173222';
  DirName[4] :='13173317';
  DirName[5] :='13173405';
  DirName[6] :='13173452';
  DirName[7] :='13173546';
  DirName[8] :='13173635';
  DirName[9] :='13173723';
  DirName[10]:='13173813';
  DirName[11]:='13173901';
  DirName[12]:='13173953';
  DirName[13]:='13174037';
  DirName[14]:='13174122';
  DirName[15]:='13174209';
  DirName[16]:='13174258';
  DirName[17]:='13174343';
  DirName[18]:='13174431';
  DirName[19]:='13174519';
  end;}
  for gSmpl:=1 to NgSmpl do begin
      str(gSmpl:3,t1);
      Form1.Label4.Visible:=true;
      Form1.Label4.Caption:='File number='+t1;
      if gst_or_gs1=1 then begin
         FNameDialog1:=RootDir+DirName[gSmpl]+'_gst\'+DirName[gSmpl]+'_gst_voltage.txt';
         FNameDialog2:=RootDir+DirName[gSmpl]+'_gst\'+DirName[gSmpl]+'_gst_current.txt';
         FNameDialog3:=RootDir+DirName[gSmpl]+'_gst\'+DirName[gSmpl]+'_gst_header.txt';
      end;
      if gst_or_gs1=2 then begin
         FNameDialog1:=RootDir+DirName[gSmpl]+'\voltage.txt';
         FNameDialog2:=RootDir+DirName[gSmpl]+'\current.txt';
         FNameDialog3:=RootDir+DirName[gSmpl]+'\parameters.txt';
         FNameDialog4:=RootDir+DirName[gSmpl]+'\GE_sequence.txt';
      end;
      {*** Run Spike Searching ***}
      F_I_curves;
      {***************************}
  end;
end;

{******************************************************************************}
function ReadAndTreatSelectedFiles :boolean;
var j,Smpl,Success :integer;
begin
  ReadAndTreatSelectedFiles:=false;
  Smpl:=0;
  for j:=1 to NOfFilesInTheList do begin
      { Find selected files in the whole list and remember them }
      if Form4.ListBox1.Selected[j-1] then begin
         Smpl:=Smpl+1;
         FNames_Umea[Smpl]:=Form4.ListBox1.Items[j-1];
//         SetLength(FNames_Params_Umea[Smpl],Pos('_trace',FNames_Umea[Smpl])-1);
//         FNames_Params_Umea[Smpl]:=FNames_Params_Umea[Smpl] +'.par';
         {***}
         Success:=ReadPastTrace(FNames_Umea[Smpl]);
         if Success=0 then exit;
         Translate_Umea_into_Lyle(Smpl);
//         Draw2Arrays(Smpl);
      end;
  end;
  NSmpl:=Smpl;
  Form1.DDSpinEdit2.Value:=1; {Smpl:=1}
  {               *********** }
  if NSmpl>0 then ReadAndDraw else exit;
  {               *********** }
  ReadAndTreatSelectedFiles:=true;
end;

end.
