unit Writing;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls, TeEngine, Series, ExtCtrls,
  TeeProcs, Chart, DDSpinEdit,
  Init_DC,ReadWrite_pars,Na_and_K;

procedure CreateWorkingDirectory;
procedure WriteTraceInFile;
procedure DCReadListOfFiles;
procedure DCReadPastTrace(FName :string);

implementation
uses DCUnit1;

procedure CreateWorkingDirectory;
var RootDir,WriteDir :string;
    Year, Month, Day, Hour, Min, Sec, MSec: Word;
begin
  GetDir(0,RootDir);
  DirOfTheProgram:=RootDir;
  DecodeDate(Now, Year, Month, Day);
  WriteDir := IntToStr(Year) + '_' + IntToStr(Month) + '_' + IntToStr(Day);
  if not DirectoryExists(WriteDir) then  MkDir(WriteDir);
  SetCurrentDir(WriteDir);
  if not DirectoryExists('Cell_1') then  MkDir('Cell_1');
  SetCurrentDir('Cell_1');
  GetDir(0,RootDir);
  DirOfTheProgram:=RootDir;
  DCForm1.DirectoryListBox1.Directory:=DirOfTheProgram;
  DCForm1.DirectoryListBox1.Update;
end;

procedure WriteTraceInFile;
var RootDir,WriteDir,FName,FName_Params,FNList :string;
    Year, Month, Day, Hour, Min, Sec, MSec: Word;
    bbb,ccc,ddd :text;
begin
  if not DCForm1.CheckBox9.Checked then exit;
  { File name }
  GetDir(0,RootDir);
  DecodeTime(Now, Hour, Min, Sec, MSec);
  FName := IntToStr(Hour) + '_' + IntToStr(Min) + '_' + IntToStr(Sec);
  FName_Params:=FName+'.par';
  FName:=FName + '_trace'+IntToStr(i_step);
  { Errors }
  FName:=FName+'_Err'+IntToStr(trunc(EndTime-StartTime-T_end));
  { Protocol name in extension }
  case Protocol of
  { BackGround }
  0: FName:=FName+'.bg';
  { Current-Clamp }
  1: if If_NaAndK=1 then FName:=FName+'.NaK' else FName:=FName+'.cc';
  { PassiveProperties }
  2: FName:=FName+'.pp';
  { Tongue }
  3: FName:=FName+'.us';
  { SMOCs }
  4: FName:=FName+'.smc';
  { Dynamic VC }
  5: FName:=FName+'.VC';
  end;
  { Writing signals }
  assign(bbb,FName); rewrite(bbb);
  i:=-1;
  repeat    i:=i+1;
    V:=Arr_V[i]; Ireal:=Arr_Ireal[i]; Icom:=Arr_Icom[i]; time:=Arr_t[i];
    write  (bbb,time:10:3,' ',V:10:3,' ',Icom:10:3,' ',Ireal:12:3,' ');
    write  (bbb,uu:10:3,' ',ss:10:3);
    if Protocol=5 then write(bbb,Arr_Vmod[i]:10:3,' ');
    if If_KillArtifacts=1 then write(bbb,Arr_Vcorr[i]:10:3,' ',Arr_G1[i]:10:3,' ');
    writeln(bbb);
  until i>=i_end;
  close(bbb);
  { Writing parameters }
  WriteParametersTo(FName_Params);
  { List of files }
  FNList:='ListOfFiles';
  assign(ddd,FNList);
  if FileExists(FNList) then begin
     reset(ddd);
     while not eof(ddd) do readln(ddd);
     append(ddd);
  end else rewrite(ddd);
  writeln(ddd,FName);
  writeln(ddd,FName_Params);
  close(ddd);
  DCForm1.ListBox1.Items.Add(FName);
  DCForm1.ListBox1.TopIndex:=DCForm1.ListBox1.Items.Count;  // ?
end;

procedure ParamsToDCForm;
begin
  DCForm1.DDSpinEdit3.Value :=T_end       ; {ms}
  DCForm1.DDSpinEdit4.Value :=AcqTime     ; {ms}
  DCForm1.DDSpinEdit9.Value :=t_StartStim ;  {ms}
  DCForm1.DDSpinEdit10.Value:=t_EndStim   ;  {ms}
  DCForm1.DDSpinEdit25.Value:=V_scale     ;  {mV/V}
  DCForm1.DDSpinEdit26.Value:=Icom_scale  ;  {pA/V}
  DCForm1.DDSpinEdit31.Value:=Ireal_scale ;  {pA/V}
  DCForm1.DDSpinEdit39.Value:=V_offset    ;  {mV}
  DCForm1.DDSpinEdit38.Value:=Icom_offset ;  {pA}
  DCForm1.DDSpinEdit40.Value:=Ireal_offset;  {pA}
  DCForm1.DDSpinEdit27.Value:=dt_draw     ;  {ms}
  DCForm1.DDSpinEdit28.Value:=Epoch   /1e3;  {s}
  DCForm1.DDSpinEdit5.Value :=PP.I_min      ;       {pA}
  DCForm1.DDSpinEdit6.Value :=PP.I_max      ;       {pA}
  DCForm1.DDSpinEdit7.Value :=PP.N_steps      ;
  DCForm1.DDSpinEdit14.Value :=PP.t1_start      ;
  DCForm1.DDSpinEdit15.Value :=PP.t1_end      ;
  DCForm1.DDSpinEdit16.Value :=PP.t2_start      ;
  DCForm1.DDSpinEdit17.Value :=PP.t2_end      ;
  DCForm1.DDSpinEdit18.Value :=PP.G_L      ;
  DCForm1.DDSpinEdit19.Value :=US.u_min      ;
  DCForm1.DDSpinEdit20.Value :=US.u_max      ;
  DCForm1.DDSpinEdit22.Value :=US.s_min      ;
  DCForm1.DDSpinEdit23.Value :=US.s_max      ;
  DCForm1.DDSpinEdit21.Value :=US.Nu_steps      ;
  DCForm1.DDSpinEdit24.Value :=US.Ns_steps      ;
  DCForm1.DDSpinEdit1.Value :=CC.I_stim      ; {pA}
  DCForm1.DDSpinEdit37.Value:=CC.g_stim      ; {nS}
  DCForm1.DDSpinEdit2.Value :=CC.T_I       ; {ms}
  DCForm1.RadioGroup2.ItemIndex:=Protocol;
  DCForm1.CheckBox15.Checked:=(If_ThresholdClamp=1);
  DCForm1.CheckBox16.Checked:=(If_FiringClamp=1);
  DCForm1.CheckBox17.Checked:=(If_KillArtifacts=1);
  DCForm1.CheckBox6.Checked :=(If_NaAndK=1);
  DCForm1.DDSpinEdit30.Value:=Vus;
  DCForm1.DDSpinEdit46.Value:=TC.FixedThreshold;
  DCForm1.DDSpinEdit47.Value:=TC.CurrentPulseAmplitude/1000; {nA}
  DCForm1.DDSpinEdit48.Value:=TC.CurrentPulseDuration;
  DCForm1.DDSpinEdit49.Value:=TC.MinISI;
  DCForm1.DDSpinEdit8.Value:=FC.rate;
  DCForm1.DDSpinEdit11.Value:=FC.Vmin;
  DCForm1.DDSpinEdit12.Value:=FC.PositivePulseCurrent/1000;  {nA}
  DCForm1.DDSpinEdit13.Value:=FC.NegativePulseCurrent/1000;  {nA}
  DCForm1.DDSpinEdit51.Value:=FC.PositivePulseDuration;
  DCForm1.DDSpinEdit32.Value:=SMOC.tau_raise;
  DCForm1.DDSpinEdit34.Value:=SMOC.tau_decay;
  DCForm1.DDSpinEdit35.Value:=SMOC.g_max;
  DCForm1.DDSpinEdit36.Value:=SMOC.V_rev;
  DCForm1.DDSpinEdit33.Value:=SMOC.rate;
  DCForm1.ComboBox3.ItemIndex:=SMOC.OrderOfKinetics-1;
  DCForm1.ComboBox4.ItemIndex:=SMOC.IfPoisson;
  DCForm1.DDSpinEdit52.Value :=CC.T_g       ; {ms}
  DCForm1.ComboBox1.ItemIndex:=CC.TypeOfInputIndex;
  DCForm1.DDSpinEdit53.Value :=CC.C_stim;
  DCForm1.DDSpinEdit54.Value :=PP.tau_m;
  DCForm1.DDSpinEdit59.Value :=US.t_StartStim_u;
  DCForm1.DDSpinEdit60.Value :=US.t_EndStim_u;
  DCForm1.DDSpinEdit61.Value :=US.t_StartStim_s;
  DCForm1.DDSpinEdit62.Value :=US.t_EndStim_s;
  DCForm1.DDSpinEdit55.Value :=US.T_pause;
  DCForm1.DDSpinEdit56.Value :=EC.G1;
  DCForm1.ComboBox2.ItemIndex:=DeviceNumber;
  DCForm1.CheckBox5.Checked:=(If_CondCompensation=1);
  DCForm1.DDSpinEdit57.Value :=EC.tau_Vfilt;
  DCForm1.DDSpinEdit58.Value :=EC.tau_Ifilt;
  DCForm1.Sketchview1.Checked:=(DCForm1.DDSpinEdit27.Value<>0); // dt_draw
  DCForm1.DDSpinEdit63.Value :=NaK.gNaP;
  DCForm1.DDSpinEdit72.Value :=NaK.gAHP;
  DCForm1.DDSpinEdit43.Value :=NaK.gNa;
  DCForm1.DDSpinEdit44.Value :=NaK.gK;
  DCForm1.DDSpinEdit45.Value :=NaK.Vshift;
  DCForm1.DDSpinEdit41.Value :=NaK.g_GJ;
//  NaK.TypeOfExpNrn:=DCForm1.ComboBox6.Items[DCForm1.ComboBox6.ItemIndex];
//  NaK.TypeOfModNrn:=DCForm1.ComboBox5.Items[DCForm1.ComboBox5.ItemIndex];
  DCForm1.CheckBox13.Checked:=(NaK.IfTurnOnModelNeuron=1);
  DCForm1.CheckBox11.Checked:=(NaK.IfIncludeVrestInVshift=1);
  DCForm1.DDSpinEdit73.Value:=DynVC.VL         ; {mV}
  DCForm1.DDSpinEdit74.Value:=DynVC.Vh0        ; {mV}
  DCForm1.DDSpinEdit79.Value:=DynVC.k          ;
  DCForm1.DDSpinEdit76.Value:=DynVC.I_scale    ; {pA/V}      //V_scale
  DCForm1.DDSpinEdit77.Value:=DynVC.Vh_scale   ; {mV/V}      //Icom_scale
  DCForm1.DDSpinEdit78.Value:=DynVC.Vreal_scale; {mV/V}
  DCForm1.DDSpinEdit75.Value:=DynVC.I_offset   ; {pA}
  DCForm1.DDSpinEdit80.Value:=Vmin ;  {mV}
  DCForm1.DDSpinEdit81.Value:=Vmax ;  {mV}
  DCForm1.DDSpinEdit82.Value:=dVmax;  {mV}
end;

procedure DCReadListOfFiles;
var FName,FName_Params,FNList,d :string;
    ddd :text;
begin
  FNList:='ListOfFiles';
  DCForm1.ListBox1.Clear;
  assign(ddd,FNList); if FileExists(FNList) then reset(ddd) else exit;
  DC_NOfFilesInTheList:=0;
  while not eof(ddd) do begin
     readln(ddd,FName);
     readln(ddd,FName_Params);
     DCForm1.ListBox1.Items.Add(FName);
     DC_NOfFilesInTheList:=DC_NOfFilesInTheList+1;
  end;
  close(ddd);
  Application.ProcessMessages;
  { Read Past Parameters }
  if not(DCForm1.CheckBox12.Checked) then begin
     ReadParametersOf(FName_Params);
     { Correspond to DCForm }
     ParamsToDCForm;
  end;
end;

procedure DCReadPastTrace(FName :string);
var
    FName_Params :string;
    bbb :text;
begin
  { Read signals }
  assign(bbb,FName);
  if FileExists(FName) then reset(bbb) else exit;
  i:=-1;
  repeat    i:=i+1;
    V:=Arr_V[i]; Ireal:=Arr_Ireal[i]; Icom:=Arr_Icom[i]; time:=Arr_t[i];
    read  (bbb,time,V,Icom,Ireal);
    read  (bbb,uu,ss);
    if Protocol=5 then read(bbb,Arr_Vmod[i]);
    if If_KillArtifacts=1 then read(bbb,Arr_Vcorr[i],Arr_G1[i]);
    readln(bbb);
    Arr_V[i]:=V; Arr_Ireal[i]:=Ireal; Arr_Icom[i]:=Icom; Arr_t[i]:=time;
  until eof(bbb);
  i_end:=i;
  close(bbb);
  { Read parameters }
  FName_Params:=FName;
  SetLength(FName_Params,Pos('_trace',FName)-1);
  FName_Params:=FName_Params +'.par';
  { if not 'Don't read parameters from file' }
  if not(DCForm1.CheckBox12.Checked) then begin
     ReadParametersOf(FName_Params);
     { Correspond to DCForm }
     ParamsToDCForm;
  end;
  DCForm1.DrawArrays;
  {***}
end;

end.
